/*******************************************************************************
*
* Copyright 2012-2014 Freescale Semiconductor, Inc.
* Copyright 2018 NXP.
* All rights reserved.
*******************************************************************************/

#ifndef __SYSTEMSTATUSWPC_H__

    #define __SYSTEMSTATUSWPC_H__

    //----------
    // INCLUDES
    //----------
    #include "wct_systemDataWPC.h"

    //---------
    // DEFINES
    //---------

    //----------
    // TYPEDEFS
    //----------

    //------------------------------------------------------------------------------
    // Device Status Structure
    typedef struct
    {
        DEVICE_STATE                DeviceState;
        BYTE                        MajorVersion : 4;
        BYTE                        MinorVersion : 4;
        BYTE                        byUsesExtendedId;
        BYTE                        ExtDeviceId[ 8 ];
        WORD                        wManufacturerId;
        WORD                        wDeviceIdMsw;
        WORD                        wDeviceIdLsw;
        WORD                        wMaxHalfWatts;
        WORD                        wDeviceFaultStatus;
        DWORD                       dwCalculatedInputPower;
        DWORD                       dwRxReportedPower;
        BYTE                        byPercentCharged;
        BYTE                        byPercentPowerUsed;
        BYTE                        byEptReasonCode;
        BYTE                        bySignalStrength;

    } DEVICE_STATUS;




    //-----------
    // VARIABLES
    //-----------


    //-----------
    // FUNCTIONS
    //-----------
    void InitDeviceStatus( BYTE byDeviceId, BYTE byActiveCoilIndex, DEVICE_STATE eDeviceState );
    void UpdateDeviceStatus( BYTE byDeviceId, DEVICE_STATE eDeviceState );
    DEVICE_STATE GetDeviceStatus( BYTE byDeviceId );
    void GetDeviceStatusStructure( BYTE byDeviceId, DEVICE_STATUS* pDeviceStatus );


#endif
