;/******************************************************************************
;*
;* Freescale Semiconductor Inc.
;* (c) Copyright 2013 Freescale Semiconductor
;* (c) Copyright 2018 NXP.
;* ALL RIGHTS RESERVED.
;*
;*******************************************************************************/

;// NOTE: This module initializes the DFLASH with the appropriate data to 
;//  emulate an 16-bit EEPROM organization


    ;//----------
    ;// INCLUDES
    ;//----------


    ;//----------
    ;// TYPEDEFS
    ;//----------


    ;//---------
    ;// DEFINES
    ;//---------

    SECTION dflash
    org p:
    
    ; DFLASH Parameter Initialization Table:
    ; Table segments are as follows:
    ;  Address Range            Segment Name
    ;  0x0000                   Diagnostic Params
    ;  0x0017                   Diagnostic Params Checksum
    ;  0x0018                   System Params
    ;  0x0033                   System Params Checksum
    ;  0x0034                   Coil 0 Operating Params
    ;  0x00AB                   Coil 0 Operating Params Checksum
    ;  0x00AC                   Calibration Params
    ;  0x00EF                   Calibration Params Checksum

; System Configuration 
 DC $00F1 ;0x00 
 DC $C104 ;0x02 
 DC $000D ;0x04 
 DC $0102 ;0x06 
 DC $00C8 ;0x08 
 DC $00C8 ;0x0A 
 DC $07D0 ;0x0C 
 DC $03E8 ;0x0E 
 DC $0000 ;0x10 
 DC $0000 ;0x12 
 DC $8005 ;0x14 
 DC $000A ;0x16 
 DC $0000 ;0x18 
 DC $AA00 ;0x1A 
  ; Coil Configuration 
 DC $AB98 ;0x1C 
 DC $0002 ;0x1E 
 DC $0041 ;0x20 
 DC $0190 ;0x22 
 DC $AB98 ;0x24 
 DC $0002 ;0x26 
 DC $0005 ;0x28 
 DC $0005 ;0x2A 
 DC $0332 ;0x2C 
 DC $0504 ;0x2E 
 DC $0FA0 ;0x30 
 DC $1770 ;0x32 
 DC $2EE0 ;0x34 
 DC $0000 ;0x36 
 DC $ADB0 ;0x38 
 DC $0001 ;0x3A 
 DC $20C8 ;0x3C 
 DC $0003 ;0x3E 
 DC $0005 ;0x40 
 DC $0005 ;0x42 
 DC $0BB8 ;0x44 
 DC $F448 ;0x46 
 DC $4E20 ;0x48 
 DC $B1E0 ;0x4A 
 DC $00C8 ;0x4C 
 DC $010A ;0x4E 
 DC $0501 ;0x50 
 DC $0314 ;0x52 
 DC $3205 ;0x54 
 DC $0A0A ;0x56 
 DC $0A0A ;0x58 
 DC $0001 ;0x5A 
 DC $0064 ;0x5C 
 DC $0000 ;0x5E 
 DC $FBD0 ;0x60 
 DC $0001 ;0x62 
 DC $0096 ;0x64 
 DC $0000 ;0x66 
 DC $22E0 ;0x68 
 DC $0002 ;0x6A 
 DC $00C8 ;0x6C 
 DC $0000 ;0x6E 
 DC $7100 ;0x70 
 DC $0002 ;0x72 
 DC $012C ;0x74 
 DC $0000 ;0x76 
 DC $BF20 ;0x78 
 DC $0002 ;0x7A 
 DC $01F4 ;0x7C 
 DC $0000 ;0x7E 
 DC $03E8 ;0x80 
 DC $0000 ;0x82 
 DC $93E0 ;0x84 
 DC $0004 ;0x86 
 DC $0190 ;0x88 
 DC $0064 ;0x8A 
 DC $1203 ;0x8C 
 DC $0000 ;0x8E 
 DC $0028 ;0x90 
 DC $0000 ;0x92 
 DC $0000 ;0x94 
 DC $BE00 ;0x96 
  ; Calibration configuration 
 DC $7E5D ;0x98 
 DC $7BCA ;0x9A 
 DC $8000 ;0x9C 
 DC $0000 ;0x9E 
 DC $406B ;0xA0 
 DC $001B ;0xA2 
 DC $B815 ;0xA4 
 DC $0014 ;0xA6 
 DC $0048 ;0xA8 
 DC $0000 ;0xAA 
 DC $AEF9 ;0xAC 
 DC $0020 ;0xAE 
 DC $4DC2 ;0xB0 
 DC $0014 ;0xB2 
 DC $009F ;0xB4 
 DC $0000 ;0xB6 
 DC $0000 ;0xB8 
 DC $0010 ;0xBA 
 DC $0000 ;0xBC 
 DC $0010 ;0xBE 
 DC $0000 ;0xC0 
 DC $0000 ;0xC2 
 DC $0000 ;0xC4 
 DC $0010 ;0xC6 
 DC $0000 ;0xC8 
 DC $0010 ;0xCA 
 DC $0000 ;0xCC 
 DC $0000 ;0xCE 
 DC $2710 ;0xD0 
 DC $0000 ;0xD2 
 DC $2AF8 ;0xD4 
 DC $0000 ;0xD6 
 DC $12B4 ;0xD8 
 DC $FFB8 ;0xDA 
 DC $0000 ;0xDC 
 DC $3B00 ;0xDE 
 
 
 ; Coil Configuration 
 ;DC $AB98 ;0x1C 
 ;DC $0002 ;0x1E 
 ;DC $0041 ;0x20 
 ;DC $0190 ;0x22 
 ;DC $AB98 ;0x24 
 ;DC $0002 ;0x26 
 ;DC $0005 ;0x28 
 ;DC $0005 ;0x2A 
 ;DC $0332 ;0x2C 
 ;DC $0504 ;0x2E 
 ;DC $0FA0 ;0x30 
 ;DC $1770 ;0x32 
 ;DC $2EE0 ;0x34 
 ;DC $0000 ;0x36 
 ;DC $ADB0 ;0x38 
 ;DC $0001 ;0x3A 
 ;DC $20C8 ;0x3C 
 ;DC $0003 ;0x3E 
 ;DC $0005 ;0x40 
 ;DC $0005 ;0x42 
 ;DC $0BB8 ;0x44 
 ;DC $F448 ;0x46 
 ;DC $4E20 ;0x48 
 ;DC $B1E0 ;0x4A 
 ;DC $00C8 ;0x4C 
 ;DC $010A ;0x4E 
 ;DC $0501 ;0x50 
 ;DC $0314 ;0x52 
 ;DC $3205 ;0x54 
 ;DC $0A0A ;0x56 
 ;DC $0A0A ;0x58 
 ;DC $0001 ;0x5A 
 ;DC $0064 ;0x5C 
 ;DC $0000 ;0x5E 
 ;DC $FBD0 ;0x60 
 ;DC $0001 ;0x62 
 ;DC $0096 ;0x64 
 ;DC $0000 ;0x66 
 ;DC $22E0 ;0x68 
 ;DC $0002 ;0x6A 
 ;DC $00C8 ;0x6C 
 ;DC $0000 ;0x6E 
 ;DC $7100 ;0x70 
 ;DC $0002 ;0x72 
 ;DC $012C ;0x74 
 ;DC $0000 ;0x76 
 ;DC $BF20 ;0x78 
 ;DC $0002 ;0x7A 
 ;DC $01F4 ;0x7C 
 ;DC $0000 ;0x7E 
 ;DC $03E8 ;0x80 
 ;DC $0000 ;0x82 
 ;DC $93E0 ;0x84 
 ;DC $0004 ;0x86 
 ;DC $0190 ;0x88 
 ;DC $0064 ;0x8A 
 ;DC $1203 ;0x8C 
 ;DC $0000 ;0x8E 
 ;DC $0000 ;0x90 
 ;DC $0000 ;0x90 
 ;DC $0000 ;0x90 
 ;DC $F400 ;0x92 
 
 ; FSL A11 EVM Rev2.1
 ; Calibration configuration 
 ;DC $7E5D ;0x94 
 ;DC $7BCA ;0x96 
 ;DC $8000 ;0x98 
 ;DC $0000 ;0x9A 
 ;DC $406B ;0x9C 
 ;DC $001B ;0x9E 
 ;DC $B815 ;0xA0 
 ;DC $0014 ;0xA2 
 ;DC $0048 ;0xA4 
 ;DC $0000 ;0xA6 
 ;DC $AEF9 ;0xA8 
 ;DC $0020 ;0xAA 
 ;DC $4DC2 ;0xAC 
 ;DC $0014 ;0xAE 
 ;DC $009F ;0xB0 
 ;DC $0000 ;0xB2 
 ;DC $0000 ;0xB4 
 ;DC $0010 ;0xB6 
 ;DC $0000 ;0xB8 
 ;DC $0010 ;0xBA 
 ;DC $0000 ;0xBC 
 ;DC $0000 ;0xBE 
 ;DC $0000 ;0xC0 
 ;DC $0010 ;0xC2 
 ;DC $0000 ;0xC4 
 ;DC $0010 ;0xC6 
 ;DC $0000 ;0xC8 
 ;DC $0000 ;0xCA 
 ;DC $2710 ;0xCC 
 ;DC $0000 ;0xCE 
 ;DC $2AF8 ;0xD0 
 ;DC $0000 ;0xD2 
 ;DC $0000 ;0xD4 
 ;DC $0000 ;0xD2 
 ;DC $0000 ;0xD4 
 ;DC $3200 ;0xD6 

 ; FSL A11 EVM Rev2 
 ; Calibration configuration 
 ;DC $7F62 ;0x94 
 ;DC $7A2A ;0x96 
 ;DC $8000 ;0x98 
 ;DC $0000 ;0x9A 
 ;DC $45C9 ;0x9C 
 ;DC $001B ;0x9E 
 ;DC $A8D9 ;0xA0 
 ;DC $0011 ;0xA2 
 ;DC $0085 ;0xA4 
 ;DC $0000 ;0xA6 
 ;DC $FFDF ;0xA8 
 ;DC $0019 ;0xAA 
 ;DC $FEB6 ;0xAC 
 ;DC $000E ;0xAE 
 ;DC $0004 ;0xB0 
 ;DC $0000 ;0xB2 
 ;DC $0000 ;0xB4 
 ;DC $0000 ;0xB6 
 ;DC $0000 ;0xB8 
 ;DC $0000 ;0xBA 
 ;DC $0000 ;0xBC 
 ;DC $0000 ;0xBE 
 ;DC $0000 ;0xC0 
 ;DC $0000 ;0xC2 
 ;DC $0000 ;0xC4 
 ;DC $0000 ;0xC6 
 ;DC $0000 ;0xC8 
 ;DC $0000 ;0xCA 
 ;DC $2710 ;0xCC 
 ;DC $0000 ;0xCE 
 ;DC $2AF8 ;0xD0 
 ;DC $0000 ;0xD2 
 ;DC $0000 ;0xD4 
 ;DC $AE00 ;0xD6 


    ENDSEC

    end

