/*******************************************************************************
*
* Copyright 2004-2014 Freescale Semiconductor, Inc.
* Copyright 2018 NXP.
* All rights reserved.
*******************************************************************************/
/*******************************************************************************
*
* File Name: appconfig.h
*
* Description: file for static configuration of the application
*              (initial values, interrupt vectors)
*
*****************************************************************************/

#ifndef __APPCONFIG_H
#define __APPCONFIG_H

/*.*************************************************************************
*
*  File generated by Graphical Configuration Tool Mon, 01/Sep/2014, 16:54:20
*
****************************************************************************.*/

#define WCT1000
#define EXTCLK 8000000L
#define EXTAL 16000000L
#define APPCFG_DFLTS_OMITTED 1
#define APPCFG_GCT_VERSION 0x02060c00L

/*.
    OCCS Configuration
--------------------------------------------
    Use Factory Trim Value: Yes
    Enable internal 32 kHz oscillator: Yes
    Use Factory Trim Value: Yes
    Power Down crystal oscillator: Yes
    Core frequency: 100 MHz 
    VCO frequency: 400 MHz 
    Loss of lock interrupt 0: Disable 
    Loss of lock interrupt 1: Disable 
    Loss of reference clock Interrupt: Disable
.*/
#define OCCS_CTRL_INIT                    0x0083U
#define OCCS_DIVBY_INIT                   0x2031U
#define OCCS_OSCTL1_INIT                  0x1620U
#define OCCS_USE_FACTORY_TRIM             1
#define OCCS_OSCTL2_INIT                  0x4100U
#define OCCS_USE_FACTORY_TRIM_TEMP        1
#define OCCS_USE_FACTORY_TRIM_32K         1

/*.
    COP Configuration
--------------------------------------------
    COP clock source: Relaxation oscilator 
    COP operation: Enable 
    COP timeout: 2.09712 sec 
    COP Runs in Stop Mode: No 
    COP Runs in Wait Mode: No 
    COP Write Protect: No 
    Enable Loss of Clock COP: No 
    Enable COP Warning Interrupt: No 
    COP Warning Interrupt Timeout: 8.16 ms 
    COP Window Timeout: 2.09712 sec
.*/
#define COP_COPCTL_INIT                   0x0202U

/*.
    SYS Configuration
--------------------------------------------
    SIM: Power Saving Modes: Stop enabled 
    Wait enabled 
         OnCE clock to processor core: Enabled when core TAP enabled 
    DMA Enable in RUN and WAIT modes: DMA enabled in all power modes 
    Enable Ext.Reset Input Filter: No , SIM - Clock on GPIO: Enable CLKO_0: No 
    SIM - Clock on GPIO: Enable CLKO_1: No 
    SIM - Peripheral Clock Enable: GPIO F: Yes, GPIO E: Yes, GPIO D: Yes, GPIO C: Yes, GPIO B: Yes, GPIO A: Yes, TMR A0: Yes
                                   TMR A1: No , TMR A2: Yes, TMR A3: Yes, SCI0: Yes, SCI1: No , QSPI0: No , QSPI1: No , IIC: Yes, MSCAN: No 
                                   CMP A: Yes, CMP B: No , CMP C: No , CMP D: No , CYC ADC: Yes, CRC: No , QDC: No , PIT0: Yes, PIT1: No , DACA: No , DACB: No 
                                   PWMCH0: Yes, PWMCH1: No , PWMCH2: Yes, PWMCH3: No , SIM - Modules Enabled in Stop: GPIO F: No , SIM - Modules Enabled in Stop: GPIO E: No , SIM - Modules Enabled in Stop: GPIO D: No , SIM - Modules Enabled in Stop: GPIO C: Yes, SIM - Modules Enabled in Stop: GPIO B: No , SIM - Modules Enabled in Stop: GPIO A: No 
    SIM - Modules Enabled in Stop: TMR A0: No , TMR A1: No , TMR A2: No , TMR A3: No , 
                                   SCI0: No , SCI1: No , QSPI0: No , QSPI1: No , IIC: No , MSCAN: No 
                                   CMP A: No , CMP B: No , CMP C: No , CMP D: No , CYC ADC: No , CRC: No , QDC: No , PIT0: Yes, PIT1: No , DACA: No , DACB: No 
                                   PWMCH0: No , PWMCH1: No , PWMCH2: No , PWMCH3: No 
    Protection of IPS and GPSxx  : Registers not protected 
    Protection of PCE, SD and PCR: Registers not protected 
    Protection of GPIO Port D: Registers not protected 
    Protection of PWRMODE: Registers not protected 
    GPIO Peripheral select registers (GPSn): ANA0/CMPA3 
                                             ANB1/CMPB_IN0 
                                             EXTAL 
                                             TXD0 
                                             RXD0 
                                             TA1 
                                             DACA 
                                             TA2 
                                             SS0_B 
                                             MOSI0 
                                             XB_IN4 
                                             XB_IN5 
                                             CANTX 
                                             CANRX 
                                             XB_IN6 
                                             SDA0 
                                             SCL0 
                                             PWMA_2B 
                                             PWMA_2A 
                                             PWMA_3B 
                                             PWMA_3A 
                                             XB_IN6 
                                             XB_IN7 
                                             SCL0 
                                             SDA0 
                                             TXD1 
                                             RXD1 
                                             Reserved 
                                             Reserved 
                                             RXD0 
    Internal Peripheral Select Register 0 (IPS0): XB_OUT34 
                                                  GPIOC4 
                                                  GPIOC6 
                                                  GPIOC13 
                                                  GPIOC3/GPIOC8/GPIOF8 
                                                  GPIOC12/GPIOF5 
    Miscellaneous Register 0 (SIM_MISC0): Enable 
                                          Disable
                                          CLKIN0 (GPIOC0 alt1) 
                                          PIT0 master, PIT1 slave 
    SIM - Interrupts: Low voltage 2.2V: Disable
                      Low voltage 2.7V: Disable
                      High voltage 2.2V: Disable
                      High voltage 2.7V: Disable
    Enable Voltage Reference Buffer: No 
    Bandgap trim: 7, Use Factory Trim Value: No 
    Power Control: Large Regulator Standby mode: Normal 
                   Small Regulator 2.7 V Supply Standby mode: Normal 
                   Small Regulator 2.7 V Supply Powerdown mode: Normal 
                   Small Regulator 1.2 V Supply Standby mode: Normal
.*/
#define SIM_CLKOSR_INIT                   0x1020U
#define SIM_GPSCL_INIT                    0x0080U
#define SIM_GPSCH_INIT                    0x0414U
#define SIM_GPSFL_INIT                    0x0004U
#define SIM_PCR_INIT                      0x0000U
#define SIM_PCE0_INIT                     0xB0FEU
#define SIM_PCE1_INIT                     0x1442U
#define SIM_PCE2_INIT                     0x108BU
#define SIM_PCE3_INIT                     0x00A0U
#define SIM_SD0_INIT                      0x0010U
#define SIM_SD2_INIT                      0x0008U
#define SIM_IPS0_INIT                     0x0100U
#define SIM_MISC0_INIT                    0x0004U

/*.
    INTC Configuration
--------------------------------------------
.*/
#define INTC_ICTL_INIT                    0x0000U
#define INT_PRIORITY_LEVEL_20             INTC_LEVEL0
#define INT_VECTOR_ADDR_28                MWCT10xx_ISR_TMRA_0
#define INT_PRIORITY_LEVEL_28             INTC_LEVEL2
#define INT_VECTOR_ADDR_36                MWCT10xx_ISR_DMA0
#define INT_PRIORITY_LEVEL_36             INTC_LEVEL0
#define INT_VECTOR_ADDR_95                MWCT10xx_ISR_PIT0_ROLLOVER
#define INT_VECTOR_ADDR_105               MWCT10xx_ISR_GPIOC

/*.
    DMA Configuration
--------------------------------------------
    DMA Channel 0: Disable
    Channel Source : Req 13: ADACB (Cyclic) End of Scan 
    Auto disable peripheral request after transfer: Yes
    Interrupt on completion: Yes
    Enable Auto-align: Disable
    Transfer mode: Cycle-steal (single)  
    Source Address: 0x0
    Destination Address: 0x0
    Source size: Word , Destination size: Word 
    Size of the source data buffer: disabled 
    Size of the destination data buffer: 1 KB 
    Increment source address: No , Increment destination address: Yes
    Bytes to transfer: 0x0
    Link mode: No linking 
    Link channel 1 (LCH1): DMA channel 1 , Link channel 2 (LCH2): DMA channel 1 
    DMA Channel 1: Disable
    Channel Source : Req  0: Reserved 
    Auto disable peripheral request after transfer: No 
    Interrupt on completion: No 
    Enable Auto-align: Disable
    Transfer mode: Continuous 
    Source Address: 0x0
    Destination Address: 0x0
    Source size: Longword , Destination size: Longword 
    Size of the source data buffer: disabled 
    Size of the destination data buffer: disabled 
    Increment source address: No , Increment destination address: No 
    Bytes to transfer: 0x0
    Link mode: No linking 
    Link channel 1 (LCH1): DMA channel 0 , Link channel 2 (LCH2): DMA channel 0 
    DMA Channel 2: Disable
    Channel Source : Req  0: Reserved 
    Auto disable peripheral request after transfer: No 
    Interrupt on completion: No 
    Enable Auto-align: Disable
    Transfer mode: Continuous 
    Source Address: 0x0
    Destination Address: 0x0
    Source size: Longword , Destination size: Longword 
    Size of the source data buffer: disabled 
    Size of the destination data buffer: disabled 
    Increment source address: No , Increment destination address: No 
    Bytes to transfer: 0x0
    Link mode: No linking 
    Link channel 1 (LCH1): DMA channel 0 , Link channel 2 (LCH2): DMA channel 0 
    DMA Channel 3: Disable
    Channel Source : Req  0: SCI0 Tx Empty 
    Auto disable peripheral request after transfer: No 
    Interrupt on completion: No 
    Enable Auto-align: Disable
    Transfer mode: Continuous 
    Source Address: 0x0
    Destination Address: 0x0
    Source size: Longword , Destination size: Longword 
    Size of the source data buffer: disabled 
    Size of the destination data buffer: disabled 
    Increment source address: No , Increment destination address: No 
    Bytes to transfer: 0x0
    Link mode: No linking 
    Link channel 1 (LCH1): DMA channel 0 , Link channel 2 (LCH2): DMA channel 0
.*/
#define DMA_REQC_INIT                     0x0D000000U
#define DMA_DCR0_INIT                     0xA02C0785U

/*.
    QT_A0 Configuration
--------------------------------------------
    Count mode: Counting mode, count rising edges of primary source 
    Timer Channel Enabled (counter starts counting immediatelly after initialized): Yes
    Primary source: Counter #0 input pin , 
    Input polarity: True , Output polarity: True 
    Input capture mode: Capture disabled, Input Edge Flag disabled 
    Output mode: Asserted while counter is active 
    Count stop mode: Count repeatedly , Count length: Count until compare and reinitialize , Count direction: Count up 
    Output enable (OFLAG to pin): No 
    Force OFLAG output at startup: No , Forced OFLAG value: 0
    Master mode (broadcast compare event): Disable
    Enable external OFLAG force (on broadcasted event): No 
    Co-channel initialization (on broadcasted event): No 
    Preload Control: 1: Upon successful compare in CMP1 , Load Reg: 255
                     2: Never , Load Reg: 0
    Interrupts: Overflow: Disabled
                Input edge: Disabled
                Compare: Disabled
                Cmp 1: Enabled 
                Cmp 2: Disabled
    Input Filter: Input Signal Sampling [timer clocks] : 0
                  Consecutive Samples Required to Agree: 3 
                  Input Signal Latency: OFF 
    Fault function: No 
    Alternative Load: No 
    Reload on Capture: No 
    Debug action: Continue 
    Enable DMA write for Comparator Preload Register CMPLD1: No 
    Enable DMA write for Comparator Preload Register CMPLD2: No 
    Enable DMA read for Input Edge Flag: No
.*/
#define QT_A0_CTRL_INIT                   0x2020U
#define QT_A0_CMP1_INIT                   0x00FFU
#define QT_A0_CMPLD1_INIT                 0x00FFU
#define QT_A0_COMSCR_INIT                 0x0041U

/*.
    QT_A2 Configuration
--------------------------------------------
    Count mode: Counting mode, count rising edges of primary source 
    Timer Channel Enabled (counter starts counting immediatelly after initialized): Yes
    Primary source: Prescaler (IPB clock/ 128) , 
    Input polarity: True , Output polarity: True 
    Input capture mode: Capture disabled, Input Edge Flag disabled 
    Output mode: Asserted while counter is active 
    Count stop mode: Count repeatedly , Count length: Roll over , Count direction: Count up 
    Output enable (OFLAG to pin): No 
    Force OFLAG output at startup: No , Forced OFLAG value: 0
    Master mode (broadcast compare event): Disable
    Enable external OFLAG force (on broadcasted event): No 
    Co-channel initialization (on broadcasted event): No 
    Preload Control: 1: Never , Load Reg: 0
                     2: Never , Load Reg: 0
    Interrupts: Overflow: Disabled
                Input edge: Disabled
                Compare: Disabled
                Cmp 1: Disabled
                Cmp 2: Disabled
    Input Filter: Input Signal Sampling [timer clocks] : 0
                  Consecutive Samples Required to Agree: 3 
                  Input Signal Latency: OFF 
    Fault function: No 
    Alternative Load: No 
    Reload on Capture: No 
    Debug action: Continue 
    Enable DMA write for Comparator Preload Register CMPLD1: No 
    Enable DMA write for Comparator Preload Register CMPLD2: No 
    Enable DMA read for Input Edge Flag: No
.*/
#define QT_A2_CTRL_INIT                   0x3E00U

/*.
    QT_A3 Configuration
--------------------------------------------
    Count mode: Counting mode, count rising edges of primary source 
    Timer Channel Enabled (counter starts counting immediatelly after initialized): Yes
    Primary source: Prescaler (IPB clock/ 16) , 
    Input polarity: True , Output polarity: True 
    Input capture mode: Capture disabled, Input Edge Flag disabled 
    Output mode: Asserted while counter is active 
    Count stop mode: Count repeatedly , Count length: Roll over , Count direction: Count up 
    Output enable (OFLAG to pin): No 
    Force OFLAG output at startup: No , Forced OFLAG value: 0
    Master mode (broadcast compare event): Disable
    Enable external OFLAG force (on broadcasted event): No 
    Co-channel initialization (on broadcasted event): No 
    Preload Control: 1: Never , Load Reg: 0
                     2: Never , Load Reg: 0
    Interrupts: Overflow: Disabled
                Input edge: Disabled
                Compare: Disabled
                Cmp 1: Disabled
                Cmp 2: Disabled
    Input Filter: Input Signal Sampling [timer clocks] : 0
                  Consecutive Samples Required to Agree: 3 
                  Input Signal Latency: OFF 
    Fault function: No 
    Alternative Load: No 
    Reload on Capture: No 
    Debug action: Continue 
    Enable DMA write for Comparator Preload Register CMPLD1: No 
    Enable DMA write for Comparator Preload Register CMPLD2: No 
    Enable DMA read for Input Edge Flag: No
.*/
#define QT_A3_CTRL_INIT                   0x3800U

/*.
    PIT_0 Configuration
--------------------------------------------
    Counter Enable: Disable
    Clock Prescaler: / 1 
    Modulo Value: 7999
    Interrupt Enable: Disable
    Clock source: RC Oscillator 8 MHz
.*/
#define PIT_0_CTRL_INIT                   0x0200U
#define PIT_0_MOD_INIT                    0x1F3FU

/*.
    GPIO_A Configuration
--------------------------------------------
    Pin  0: Function: ANA0/CMPA_IN3 , PullUp: Disable , 
    Pin  1: Function: ANA1/CMPA_IN0 , PullUp: Disable , 
    Pin  2: Function: ANA2/VREFHA/CMPA_IN1 , PullUp: Disable ,
.*/
#define GPIO_A_PER_INIT                   0x00FFU
#define GPIO_A_PPMODE_INIT                0x00FFU

/*.
    GPIO_B Configuration
--------------------------------------------
    Pin  0: Function: ANB0/CMPB_IN3 , PullUp: Disable , 
    Pin  1: Function: GPIO , Direction: Input , PullUp: Disable , Interrupt: Disable, Int.Polarity: Active low , 
    Pin  2: Function: ANB2/VREFHB/CMPC_IN3 , PullUp: Disable ,
.*/
#define GPIO_B_PUR_INIT                   0x0010U
#define GPIO_B_DDR_INIT                   0x0009U
#define GPIO_B_PER_INIT                   0x00E5U
#define GPIO_B_IPOLR_INIT                 0x0002U
#define GPIO_B_PPMODE_INIT                0x00FFU

/*.
    GPIO_C Configuration
--------------------------------------------
    Pin  2: Function: TXD0 , PullUp: Disable , 
    Pin  3: Function: RXD0 , PullUp: Disable , 
    Pin  4: Function: GPIO , Direction: Output , Init.Value: Low - 0 , Interrupt: Disable, Int.Polarity: Active high , Output-Mode: Push-pull , 
    Pin  6: Function: GPIO , Direction: Input , PullUp: Disable , Interrupt: Disable, Int.Polarity: Active low , 
    Pin  8: Function: GPIO , Direction: Output , Init.Value: Low - 0 , Interrupt: Disable, Int.Polarity: Active high , Output-Mode: Push-pull , 
    Pin  9: Function: GPIO , Direction: Output , Init.Value: High - 1 , Interrupt: Disable, Int.Polarity: Active high , Output-Mode: Push-pull , 
    Pin 10: Function: GPIO , Direction: Output , Init.Value: High - 1 , Interrupt: Disable, Int.Polarity: Active high , Output-Mode: Push-pull ,
.*/
#define GPIO_C_DDR_INIT                   0x0710U
#define GPIO_C_PER_INIT                   0x200FU
#define GPIO_C_IPOLR_INIT                 0x0040U
#define GPIO_C_DR_INIT                    0x0600U

/*.
    GPIO_D Configuration
--------------------------------------------
    Pin  0: Function: TDI , PullUp: Disable , 
    Pin  1: Function: TDO , PullUp: Disable , 
    Pin  2: Function: TCK , PullUp: Disable , 
    Pin  3: Function: TMS , PullUp: Disable , 
    Pin  4: Function: RESET , PullUp: Disable ,
.*/
#define GPIO_D_PUR_INIT                   0x0000U
#define GPIO_D_DDR_INIT                   0x00E0U
#define GPIO_D_PER_INIT                   0x001FU
#define GPIO_D_PPMODE_INIT                0x001FU
#define GPIO_D_DRIVE_INIT                 0x0000U

/*.
    GPIO_E Configuration
--------------------------------------------
    Pin  0: Function: PWM0B , PullUp: Disable , 
    Pin  1: Function: PWM0A , PullUp: Disable , 
    Pin  2: Function: GPIO , Direction: Input , PullUp: Disable , Interrupt: Disable, Int.Polarity: Active high , 
    Pin  3: Function: GPIO , Direction: Input , PullUp: Disable , Interrupt: Disable, Int.Polarity: Active high , 
    Pin  4: Function: PWM2B , PullUp: Disable , 
    Pin  5: Function: GPIO , Direction: Output , Init.Value: Low - 0 , Interrupt: Disable, Int.Polarity: Active high , Output-Mode: Push-pull ,
.*/
#define GPIO_E_DDR_INIT                   0x0030U
#define GPIO_E_PER_INIT                   0x00D3U
#define GPIO_E_PPMODE_INIT                0x00FFU

/*.
    GPIO_F Configuration
--------------------------------------------
    Pin  2: Function: GPIO , Direction: Output , Init.Value: Low - 0 , Interrupt: Disable, Int.Polarity: Active high , Output-Mode: Push-pull , 
    Pin  3: Function: GPIO , Direction: Input , PullUp: Disable , Interrupt: Disable, Int.Polarity: Active high ,
.*/
#define GPIO_F_DDR_INIT                   0x00F5U
#define GPIO_F_PER_INIT                   0x0002U
#define GPIO_F_PPMODE_INIT                0x01FFU

/*.
    XBAR_A Configuration
--------------------------------------------
    0. DMARequest0.: Logic0 
    1. DMARequest1.: Logic0 
    2. DMARequest2.: Logic0 
    3. DMARequest3.: Logic0 
    4. PackagePinGPIO_C14.: Logic0 
    5. PackagePinGPIO_C15.: Logic0 
    6. PackagePinGPIO_C8/GPIO_F2.: Logic0 
    7. PackagePinGPIO_F3.: Logic0 
    8. PackagePinGPIO_C9/GPIO_F4.: Logic0 
    9. PackagePinGPIO_C10/GPIO_F5.: Logic0 
    10. PackagePinGPIO_F8.: Logic0 
    11. PackagePinGPIO_C2.: Logic0 
    12. ADCA(CyclicADC)Trigger.: Logic0 
    13. ADCB(CyclicADC)Trigger.: PWMA0_TRIG0 
    14. 12-bitDACBSYNC_IN.: Logic0 
    15. 12-bitDACASYNC_IN.: Logic0 
    16. ComparatorAWindow/Sample.: Logic0 
    17. ComparatorBWindow/Sample.: Logic0 
    18. ComparatorCWindow/Sample.: Logic0 
    19. ComparatorDWindow/Sample.: Logic0 
    20. PWM0externalinput.: Logic0 
    21. PWM1externalinput.: Logic0 
    22. PWM2externalinput.: Logic0 
    23. PWM3externalinput.: Logic0 
    24. PWM0ExternalSynchronizationsignal.: Logic0 
    25. PWM1ExternalSynchronizationsignal.: Logic0 
    26. PWM2ExternalSynchronizationsignal.: Logic0 
    27. PWM3ExternalSynchronizationsignal.: Logic0 
    28. PWMExternalClocksignal.: Logic0 
    29. PWMmoduleFAULT0.: Logic0 
    30. PWMmoduleFAULT1.: Logic0 
    31. PWMmoduleFAULT2.: Logic0 
    32. PWMmoduleFAULT3.: Logic0 
    33. PWMExternalOutputForcesignal.: Logic0 
    34. QuadTimerA0Input.: PWMA0_TRIG0 
    35. QuadTimerA1Input.: Logic0 
    36. QuadTimerA2Input.: Logic0 
    37. QuadTimerA3Input.: Logic0 
    38. SCI0RXD.: Logic0 
    39. SCI1RXD.: Logic0 
    40. ExternalWatchdogMonitor.: Logic0 
    Edge Detection: Never 
    Enable DMA: No 
    Enable Interrupt Out0: No 
    Edge Detection: Never 
    Enable DMA: No 
    Enable Interrupt Out1: No 
    Edge Detection: Never 
    Enable DMA: No 
    Enable Interrupt Out2: No 
    Edge Detection: Never 
    Enable DMA: No 
    Enable Interrupt Out3: No
.*/
#define XBAR_A_SEL6_INIT                  0x1200U
#define XBAR_A_SEL17_INIT                 0x0012U

/*.
    PWM_A_Common Configuration
--------------------------------------------
    Monitor PLL State: Not locked. No PLL check 
    Fault0 Level: Low 
    Fault1 Level: Low 
    Fault2 Level: Low 
    Fault3 Level: Low 
    Fault0 Clearing: Manual 
    Fault1 Clearing: Manual 
    Fault2 Clearing: Manual 
    Fault3 Clearing: Manual 
    Fault0 Safety Mode: Safe 
    Fault1 Safety Mode: Safe 
    Fault2 Safety Mode: Safe 
    Fault3 Safety Mode: Safe 
    Fault Enable Mode: Full only 
    Full only: Full only 
               Full only 
               Full only 
    Fault Glitch Stretching: Enabled 
    Fault Filter Period: 0
    Fault Filter Count: 3 
    Fault 0 Pin: Disable
    Fault 1 Pin: Disable
    Fault 2 Pin: Disable
    Fault 3 Pin: Disable
    Submodule 0: Disable Pins PWMA by Fault: Fault 0: No 
                 Disable Pins PWMA by Fault: Fault 1: No 
                 Disable Pins PWMA by Fault: Fault 2: No 
                 Disable Pins PWMA by Fault: Fault 3: No 
                 Disable Pins PWMB by Fault: Fault 0: No 
                 Disable Pins PWMB by Fault: Fault 1: No 
                 Disable Pins PWMB by Fault: Fault 2: No 
                 Disable Pins PWMB by Fault: Fault 3: No 
                 Disable Pins PWMX by Fault: Fault 0: No 
                 Disable Pins PWMX by Fault: Fault 1: No 
                 Disable Pins PWMX by Fault: Fault 2: No 
                 Disable Pins PWMX by Fault: Fault 3: No 
                 Disable Pins PWMX by Fault: PWMA Fault State: Logic 0 
                 Disable Pins PWMX by Fault: PWMB Fault State: Logic 0 
                 Disable Pins PWMX by Fault: PWMX Fault State: Logic 0 
    Submodule 1: Disable Pins PWMA by Fault: Fault 0: Yes
                 Disable Pins PWMA by Fault: Fault 1: Yes
                 Disable Pins PWMA by Fault: Fault 2: Yes
                 Disable Pins PWMA by Fault: Fault 3: Yes
                 Disable Pins PWMB by Fault: Fault 0: Yes
                 Disable Pins PWMB by Fault: Fault 1: Yes
                 Disable Pins PWMB by Fault: Fault 2: Yes
                 Disable Pins PWMB by Fault: Fault 3: Yes
                 Disable Pins PWMX by Fault: Fault 0: Yes
                 Disable Pins PWMX by Fault: Fault 1: Yes
                 Disable Pins PWMX by Fault: Fault 2: Yes
                 Disable Pins PWMX by Fault: Fault 3: Yes
                 Disable Pins PWMX by Fault: PWMA Fault State: Logic 0 
                 Disable Pins PWMX by Fault: PWMB Fault State: Logic 0 
                 Disable Pins PWMX by Fault: PWMX Fault State: Logic 0 
    Submodule 2: Disable Pins PWMA by Fault: Fault 0: No 
                 Disable Pins PWMA by Fault: Fault 1: No 
                 Disable Pins PWMA by Fault: Fault 2: No 
                 Disable Pins PWMA by Fault: Fault 3: No 
                 Disable Pins PWMB by Fault: Fault 0: No 
                 Disable Pins PWMB by Fault: Fault 1: No 
                 Disable Pins PWMB by Fault: Fault 2: No 
                 Disable Pins PWMB by Fault: Fault 3: No 
                 Disable Pins PWMX by Fault: Fault 0: No 
                 Disable Pins PWMX by Fault: Fault 1: No 
                 Disable Pins PWMX by Fault: Fault 2: No 
                 Disable Pins PWMX by Fault: Fault 3: No 
                 Disable Pins PWMX by Fault: PWMA Fault State: Logic 0 
                 Disable Pins PWMX by Fault: PWMB Fault State: Logic 0 
                 Disable Pins PWMX by Fault: PWMX Fault State: Logic 0 
    Submodule 3: Disable Pins PWMA by Fault: Fault 0: Yes
                 Disable Pins PWMA by Fault: Fault 1: Yes
                 Disable Pins PWMA by Fault: Fault 2: Yes
                 Disable Pins PWMA by Fault: Fault 3: Yes
                 Disable Pins PWMB by Fault: Fault 0: Yes
                 Disable Pins PWMB by Fault: Fault 1: Yes
                 Disable Pins PWMB by Fault: Fault 2: Yes
                 Disable Pins PWMB by Fault: Fault 3: Yes
                 Disable Pins PWMX by Fault: Fault 0: Yes
                 Disable Pins PWMX by Fault: Fault 1: Yes
                 Disable Pins PWMX by Fault: Fault 2: Yes
                 Disable Pins PWMX by Fault: Fault 3: Yes
                 Disable Pins PWMX by Fault: PWMA Fault State: Logic 0 
                 Disable Pins PWMX by Fault: PWMB Fault State: Logic 0 
                 Disable Pins PWMX by Fault: PWMX Fault State: Logic 0
.*/
#define PWM_A_MCTRL_INIT                  0x0007U
#define PWM_A_MCTRL2_INIT                 0x0000U
#define PWM_A_OUTEN_INIT                  0x0110U
#define PWM_A_FCTRL0_INIT                 0x00F0U
#define PWM_A_FSTS_INIT                   0x00F0U
#define PWM_A_FFILT_INIT                  0x8000U

/*.
    PWM_A_0 Configuration
--------------------------------------------
    Debug Mode Operation: Run 
    Wait Mode Operation: Run 
    Load Mode: End cycle 
    Load OK: Yes
    PWM Clock Enable: No 
    Clock Source: IPBus Clock 
    Prescaler: fclk/1 
    INIT register: 0
    VAL1 register: 286
    Fraction (FRACVAL1): 0
    Sync. source: Local sync (PWMX) 
    Reload source: This module 
    Reload Frequency: Every opportunity 
    Half Cycle Reload: Disable
    Full Cycle Reload: Enable 
    PWMA Mask: Normal 
    PWMB Mask: Normal 
    PWMX Mask: Normal 
    PWMA Output Polarity: Active High 
    PWMB Output Polarity: Active High 
    PWMX Output Polarity: Active High 
    PWMA Output enable: Enabled 
    PWMB Output enable: Enabled 
    PWMX Output enable: Disabled 
    PWMA and PWMB Pair Operation: Independent 
    Initialize value registers: Enable 
    PWM Value 2: 0
    PWM Value 3: 0
    PWM Value 4: 0
    PWM Value 5: 0
    PWM Value X: 0
    Value 0: Enable 
    Value1: Disable
    Value 2: Disable
    Value3: Disable
    Value 4: Disable
    Value5: Disable
    Software Controlled Output: Logic 0 
                                Logic 0 
    Force Initialization Enable: No 
    Source of FORCE OUTPUT signal: Local force CTRL2[FORCE] 
    Dead Time Source 23: PWM23 
    Dead Time Source 45: PWM45 
    PWM45 Initial Value: Logic 0 
                         Logic 0 
    PWMX Initial Value: Logic 0 
    Reload: Disable
    Reload Error: Disable
    Value 0 Compare: Disable
    Value 1 Compare: Disable
    Value 2 Compare: Disable
    Value 3 Compare: Disable
    Value 4 Compare: Disable
    Value 5 Compare: Disable
    Capture A0: Disable
    Capture A1: Disable
    Capture B0: Disable
    Capture B1: Disable
    Capture X0: Disable
    Capture X1: Disable
    Capture A Input select: Raw PWMA input 
    Capture B Input select: Raw PWMA input 
    Capture X Input select: Raw PWMA input 
    One Shot mode enable: Disable
                          Disable
                          Disable
    Edge Counter Enable: Disable
                         Disable
                         Disable
    Edge Compare A Value: 0
    Edge Compare B Value: 0
    Edge Compare X Value: 0
    Capture A0 Edge Select: Disabled 
    Capture A1 Edge Select: Disabled 
    Capture B0 Edge Select: Disabled 
    Capture B1 Edge Select: Disabled 
    Capture X0 Edge Select: Disabled 
    Capture X1 Edge Select: Disabled 
    PWMX Double Switching: Disable
    Split DBLPWM signal to PWMA and PWMB: Disable
    Capture A0: Disable
    Capture A1: Disable
    Capture B0: Disable
    Capture B1: Disable
    Capture X0: Disable
    Capture X1: Disable
    Source of capture DMA: DMA disabled 
    Enable DMA Write Requests For alue Registers: No 
    Output Trigger 0 Source: PWM_OUT_TRIG0 
    Output Trigger 1 Source: PWM_OUT_TRIG1
.*/
#define PWM_A_0_CTRL_INIT                 0x0400U
#define PWM_A_0_CTRL2_INIT                0xE000U
#define PWM_A_0_USE_PWMVAL                1
#define PWM_A_0_INIT_INIT                 0x0000U
#define PWM_A_0_VAL1_INIT                 0x011EU
#define PWM_A_0_VAL0_INIT                 0x0000U
#define PWM_A_0_VAL2_INIT                 0x0000U
#define PWM_A_0_VAL3_INIT                 0x0000U
#define PWM_A_0_VAL4_INIT                 0x0000U
#define PWM_A_0_VAL5_INIT                 0x0000U
#define PWM_A_0_FRACVAL2_INIT             0x0000U
#define PWM_A_0_FRACVAL3_INIT             0x0000U
#define PWM_A_0_FRACVAL4_INIT             0x0000U
#define PWM_A_0_FRACVAL5_INIT             0x0000U
#define PWM_A_0_TCTRL_INIT                0x0001U
#define PWM_A_0_DTCNT0_INIT               0x0000U
#define PWM_A_0_DTCNT1_INIT               0x0000U
#define PWM_A_0_DISMAP0_INIT              0x0000U
#define PWM_A_0_DISMAP1_INIT              0x0000U

/*.
    PWM_A_2 Configuration
--------------------------------------------
    Debug Mode Operation: Stop 
    Wait Mode Operation: Stop 
    Load Mode: End cycle 
    Load OK: Yes
    PWM Clock Enable: No 
    Clock Source: IPBus Clock 
    Prescaler: fclk/128 
    INIT register: 0
    VAL1 register: 780
    Fraction (FRACVAL1): 0
    Sync. source: Local sync (PWMX) 
    Reload source: This module 
    Reload Frequency: Every opportunity 
    Half Cycle Reload: Disable
    Full Cycle Reload: Enable 
    PWMA Mask: Normal 
    PWMB Mask: Normal 
    PWMX Mask: Normal 
    PWMA Output Polarity: Active High 
    PWMB Output Polarity: Active High 
    PWMX Output Polarity: Active High 
    PWMA Output enable: Disabled 
    PWMB Output enable: Disabled 
    PWMX Output enable: Disabled 
    PWMA and PWMB Pair Operation: Independent 
    Initialize value registers: Disable
    Value 0: Disable
    Value1: Disable
    Value 2: Disable
    Value3: Disable
    Value 4: Disable
    Value5: Disable
    Software Controlled Output: Logic 0 
                                Logic 0 
    Force Initialization Enable: No 
    Source of FORCE OUTPUT signal: Local force CTRL2[FORCE] 
    Dead Time Source 23: PWM23 
    Dead Time Source 45: PWM45 
    PWM45 Initial Value: Logic 0 
                         Logic 0 
    PWMX Initial Value: Logic 0 
    Reload: Disable
    Reload Error: Disable
    Value 0 Compare: Disable
    Value 1 Compare: Disable
    Value 2 Compare: Disable
    Value 3 Compare: Disable
    Value 4 Compare: Disable
    Value 5 Compare: Disable
    Capture A0: Disable
    Capture A1: Disable
    Capture B0: Disable
    Capture B1: Disable
    Capture X0: Disable
    Capture X1: Disable
    Capture A Input select: Raw PWMA input 
    Capture B Input select: Raw PWMA input 
    Capture X Input select: Raw PWMA input 
    One Shot mode enable: Disable
                          Disable
                          Disable
    Edge Counter Enable: Disable
                         Disable
                         Disable
    Edge Compare A Value: 0
    Edge Compare B Value: 0
    Edge Compare X Value: 0
    Capture A0 Edge Select: Disabled 
    Capture A1 Edge Select: Disabled 
    Capture B0 Edge Select: Disabled 
    Capture B1 Edge Select: Disabled 
    Capture X0 Edge Select: Disabled 
    Capture X1 Edge Select: Disabled 
    PWMX Double Switching: Disable
    Split DBLPWM signal to PWMA and PWMB: Disable
    Capture A0: Disable
    Capture A1: Disable
    Capture B0: Disable
    Capture B1: Disable
    Capture X0: Disable
    Capture X1: Disable
    Source of capture DMA: DMA disabled 
    Enable DMA Write Requests For alue Registers: No 
    Output Trigger 0 Source: PWM_OUT_TRIG0 
    Output Trigger 1 Source: PWM_OUT_TRIG1
.*/
#define PWM_A_2_CTRL_INIT                 0x0470U
#define PWM_A_2_CTRL2_INIT                0x2000U
#define PWM_A_2_INIT_INIT                 0x0000U
#define PWM_A_2_VAL1_INIT                 0x030CU
#define PWM_A_2_VAL0_INIT                 0x0000U
#define PWM_A_2_VAL2_INIT                 0x0000U
#define PWM_A_2_VAL3_INIT                 0x0000U
#define PWM_A_2_VAL4_INIT                 0x0000U
#define PWM_A_2_VAL5_INIT                 0x0000U
#define PWM_A_2_FRACVAL2_INIT             0x0000U
#define PWM_A_2_FRACVAL3_INIT             0x0000U
#define PWM_A_2_FRACVAL4_INIT             0x0000U
#define PWM_A_2_FRACVAL5_INIT             0x0000U
#define PWM_A_2_DISMAP0_INIT              0xF000U

/*.
    ADC Configuration
--------------------------------------------
    Clock frequency: 20 MHz 
    Trigger source: Software only 
    Channel Configuration: ANA0-ANA1: Single ended , 
                           ANA2-ANA3: Single ended , 
                           ANB0-ANB1: Single ended , 
                           ANB2-ANB3: Single ended , 
                           ANA4-ANA5: Single ended , 
                           ANA6-ANA7: Single ended , 
                           ANB4-ANB5: Single ended , 
                           ANB6-ANB7: Single ended , 
    Channel to Sample Mapping: SMP0: ANA0 , SMP1: ANA1 , SMP2: ANA2 , 
                               SMP8: ANB2 , SMP9: ANB0 , 
    Scan Mode: Triggered parallel 
    ANB simulataneous to ANA: No 
    Enabled samples: / SMP0 SMP1 SMP2 / / SMP8 SMP9 / / 
    Zero crossing mode: SMP0: Disabled , SMP1: Disabled , SMP2: Disabled , SMP3: Disabled 
                        SMP4: Disabled , SMP5: Disabled , SMP6: Disabled , SMP7: Disabled 
                        SMP8: Disabled , SMP9: Disabled , SMP10: Disabled , SMP11: Disabled 
                        SMP12: Disabled , SMP13: Disabled , SMP14: Disabled , SMP15: Disabled 
                        SMP16: Disabled , SMP17: Disabled , SMP18: Disabled , SMP19: Disabled 
    Auto Power Down Mode: Disable
    Auto Stand-by Mode: Disable
    Power down converter A (ANA0-ANA7): No 
    Power down converter B (ANB0-ANB7): No 
    Power down voltage reference: No 
    Power up delay: 26, Power Control: 1.3 us 
    Converter1 VREFLO source: Internal VSSA
    Converter1 VREFH  source: Internal VDDA
    Converter0 VREFLO source: Internal VSSA
    Converter0 VREFH  source: Internal VDDA
    Interrupts: ANA Conversion complete: Enabled 
                ANB Conversion complete: Disabled
                High limit error: Disabled
                Low limit error: Disabled
                Zero crossing: Disabled
    ANA channel Gain Configuration: Gain ANA0: 1x , Gain ANA1: 1x 
                                    Gain ANA2: 1x , Gain ANA3: 1x 
                                    Gain ANA4: 1x , Gain ANA5: 1x 
                                    Gain ANA6: 1x , Gain ANA7: 1x 
                                    Gain ANA temp.: 1x , Gain ANA Ain.: 1x 
    ANB channel Gain Configuration: Gain ANB0: 1x , Gain ANB1: 1x 
                                    Gain ANB2: 1x , Gain ANB3: 1x 
                                    Gain ANB4: 1x , Gain ANB5: 1x 
                                    Gain ANB6: 1x , Gain ANB7: 1x 
                                    Gain ANB temp.: 1x , Gain ANB Ain.: 1x 
    ANA Enable: No 
    ANB Enable: Yes
    DMA Trigger Source: End Scan 
    ADCA6 input source: Normal (ADCA6 pin) 
    ADCA7 input source: Normal (ADCA7 pin) 
    ADCB6 input source: Normal (ADCB6 pin) 
    ADCB7 input source: Normal (ADCB7 pin)
.*/
#define ADC_ADCR1_INIT                    0x0805U
#define ADC_ADCR2_INIT                    0x9004U
#define ADC_ADLST1_INIT                   0x0210U
#define ADC_ADLST2_INIT                   0x430AU
#define ADC_ADLST3_INIT                   0x3B8AU
#define ADC_ADLST4_INIT                   0x0000U
#define ADC_ADSDIS_INIT                   0xFCF8U
#define ADC_ADCPOWER_INIT                 0x01A0U

/*.
    SCI_0 Configuration
--------------------------------------------
    Baudrate: 38402 bps 
    Enable Receiver: Enable 
    Enable Transmitter: Enable 
    Data word length: 8 bits 
    Parity: None 
    Polarity: True polarity 
    Loop mode: Disable
    Function in Wait Mode: SCI module enabled in Wait Mode 
    Interrupts: RX Full: Disable
                RX Error: Disable
                TX Empty: Disable
                TX Empty: Disable
    Enable RX and TX FIFO Queues: Disable
    RX Active Edge: Disable
    Enable TX DMA: Disable
    Enable RX DMA: Disable
    Hold off entry to stop mode: No
.*/
#define SCI_0_SCIBR_INIT                  0x0516U
#define SCI_0_SCICR_INIT                  0x000CU
#define SCI_0_SCICR2_INIT                 0x1080U
#define SCI_0_RX_BUFFER_OKLIMIT           0x000FU
#define SCI_0_RX_BUFFER_LOWLIMIT          0x000AU
#define SCI_0_SCICR3_INIT                 0x0000U

/*.
    IIC Configuration
--------------------------------------------
    I2C Module   : Enable 
    Slave Address: 0x5A
    Enable General Call Address: Disable
    SCL Low Time Out: 0
    Enable Fast NACK/ACK (writing 0 to TXAK sends NACK/ACK): No 
    Enable Second IIC Address: No 
    SMBus address: 0x0
    Timeout counter clock select: bus/64 
    I2C Interrupt: Disabled
    Enable Wake Up in Stop: No 
    Enable Timeout High 2 Interrupt: No 
    Input Glitch Filter: 0
    Enable DMA: No 
    Drive capability: Normal drive 
    Independent slave baud rate: Disable
    Stop Hold Enable: Disabled
    Start/Stop Interrupt: Disabled
    Enable Range mode: No 
    Range slave address: 0x0
.*/
#define IIC_IICF_INIT                     0x58U
#define IIC_IICA1_INIT                    0xB4U
#define IIC_IICC1_INIT                    0x80U
#define IIC_IICSMB_INIT                   0x08U

/*.
    FTFA Configuration
--------------------------------------------
    Command Complete interrupt: Disable
    Read Collision Error interrupt: Disable
.*/
#define FTFA_FPROT0_INIT                  0xFFU
#define FTFA_FPROT1_INIT                  0xFFU
#define FTFA_FPROT2_INIT                  0xFFU
#define FTFA_FPROT3_INIT                  0xFFU


/*.         End of autogenerated code
********************************************************************** ..*/

#endif
