;/******************************************************************************
;*
;* Freescale Semiconductor Inc.
;* (c) Copyright 2013 Freescale Semiconductor
;* (c) Copyright 2018 NXP
;* ALL RIGHTS RESERVED.
;*
;******************************************************************************/


;// NOTE: This module initializes the FLASH security locations with the appropriate
;//       data to secure the device.  

;// Do not include this file for DEBUG builds

    ;//----------
    ;// INCLUDES
    ;//----------


    ;//----------
    ;// TYPEDEFS
    ;//----------


    ;//---------
    ;// DEFINES
    ;//---------

    SECTION flash_config
    org p:

    DC    $0000         ; Backdoor comparison key
    DC    $0000
    DC    $0000
    DC    $0000
    DC    $FFFF         ; FTFA_FPROTn default values (all sectors unprotected)
    DC    $FFFF
    DC    $0000         ; Reserved
    DC    $0000         ; MSB = FTFA_FOPT default value, LSB = FTFA_FSEC default value (secure, mass erase enabled)

    ; FTFA_FSEC Registor Description

    ; FTFA_FSEC[6:7]
    ; Backdoor Key Security Enable
    ; 0b00 ==> Backdoor key access disabled
    ; 0b01 ==> Backdoor key access disabled (preferred KEYEN state to disable backdoor key access)
    ; 0b10 ==> Backdoor key access enabled
    ; 0b11 ==> Backdoor key access disabled

    ; FTFA_FSEC[5:4]
    ; Mass Erase Enable Bits
    ; 0b00 ==> Mass erase is enabled
    ; 0b01 ==> Mass erase is enabled
    ; 0b10 ==> Mass erase is disabled
    ; 0b11 ==> Mass erase is enabled
     

    ; FTFA_FSEC[3:2]
    ; Freescale Failure Analysis Access Code
    ; 0b00 ==> Freescale factory access granted
    ; 0b01 ==> Freescale factory access denied
    ; 0b10 ==> Freescale factory access denied
    ; 0b11 ==> Freescale factory access granted
     
    ; FTFA_FSEC[1:0]
    ; Flash Security
    ; 0b00 ==> MCU security status is secure
    ; 0b01 ==> MCU security status is secure
    ; 0b10 ==> MCU security status is unsecure (The standard shipping condition of the flash memory module is unsecure.)
    ; 0b11 ==> MCU security status is secure


    ENDSEC

    end

