/*******************************************************************************
*
* Copyright 2012-2014 Freescale Semiconductor, Inc.
* Copyright 2018 NXP.
* All rights reserved.
*******************************************************************************/

#ifndef __LOWPOWERMODE_H__
#define __LOWPOWERMODE_H__

//----------
// INCLUDES
//----------

#include "application.h"
#include "peripheralinit.h"
#include "wct_hal_cfg.h"
#include "wct_lib.h"
#include "wct_hal.h"


//-----------------
// PRIVATE DEFINES
//-----------------

#define DISABLE_SIM_PCE0_CLOCK (SIM_PCE0&=~(SIM_PCE0_TA2+SIM_PCE0_TA3))
#if HARDWARE_OVERCURRENT_SUPPORTED
#define DISABLE_SIM_PCE1_CLOCK (SIM_PCE1&=~SIM_PCE1_DAC)
#define DISABLE_SIM_PCE2_CLOCK (SIM_PCE2&=~SIM_PCE2_CMPA)
#else
#define DISABLE_SIM_PCE1_CLOCK 
#define DISABLE_SIM_PCE2_CLOCK 
#endif
#define DISABLE_SIM_PCE3_CLOCK (SIM_PCE3&=~SIM_PCE3_PWMACH0)

#define ENABLE_SIM_PCE0_CLOCK (SIM_PCE0|=(SIM_PCE0_TA2+SIM_PCE0_TA3))
#if HARDWARE_OVERCURRENT_SUPPORTED
#define ENABLE_SIM_PCE1_CLOCK (SIM_PCE1|=SIM_PCE1_DAC)
#define ENABLE_SIM_PCE2_CLOCK (SIM_PCE2|=SIM_PCE2_CMPA)
#else
#define ENABLE_SIM_PCE1_CLOCK 
#define ENABLE_SIM_PCE2_CLOCK 
#endif
#define ENABLE_SIM_PCE3_CLOCK (SIM_PCE3|=SIM_PCE3_PWMACH0)


//-----------
// FUNCTIONS
//-----------
void uControllerEnterStopMode( void );
void uControllerEnterStopModeMs( WORD wStopTimeMs );
void Cpu_SetHighSpeed(void);
void Cpu_SetLowSpeed(void);
void Cpu_SetHighSpeed_LP(void);
void Cpu_SetLowSpeed_LP(void);


#endif
