/*******************************************************************************
*
* Copyright 2012-2014 Freescale Semiconductor, Inc.
* Copyright 2018 NXP.
* All rights reserved.
*******************************************************************************/

//---------------------------
// STANDARD LIBRARY INCLUDES
//---------------------------


//----------------------
// APPLICATION INCLUDES
//----------------------
#include "peripheralInit.h"
#include "application.h"
#include "qsci.h"
#include "delay.h"
#include "adc.h"
#include "comparator.h"
#include "display.h"
#include "flash.h"
#include "i2c.h"
#include "sound.h"
#include "occs.h"

//-----------------
// PRIVATE DEFINES
//-----------------


//-------------------
// PRIVATE VARIABLES
//-------------------


//-------------------
// PRIVATE FUNCTIONS
//-------------------


//------------------
// PUBLIC VARIABLES
//------------------


//------------------
// PUBLIC FUNCTIONS
//------------------
inline void SimInit( void )
{
  #ifdef SIM_CONROL_INIT
  SIM_CTRL = SIM_CONROL_INIT;
  #endif
  #ifdef SIM_CLKOSR_INIT
  SIM_CLKOUT = SIM_CLKOSR_INIT;
  #endif

  #ifdef SIM_GPSAL_INIT
  SIM_GPSAL = SIM_GPSAL_INIT;
  #endif
  #ifdef SIM_GPSBL_INIT
  SIM_GPSBL = SIM_GPSBL_INIT;
  #endif
  #ifdef SIM_GPSCL_INIT
  SIM_GPSCL = SIM_GPSCL_INIT;
  #endif
  #ifdef SIM_GPSCH_INIT
  SIM_GPSCH = SIM_GPSCH_INIT;
  #endif
  #ifdef SIM_GPSEL_INIT
  SIM_GPSEL = SIM_GPSEL_INIT;
  #endif
  #ifdef SIM_GPSFL_INIT
  SIM_GPSFL = SIM_GPSFL_INIT;
  #endif
  #ifdef SIM_GPSFH_INIT
  SIM_GPSFH = SIM_GPSFH_INIT;
  #endif

  #ifdef SIM_PCR_INIT
  SIM_PCR = SIM_PCR_INIT;
  #endif
  #ifdef SIM_PCE0_INIT
  SIM_PCE0 = SIM_PCE0_INIT;
  #endif
  #ifdef SIM_PCE1_INIT
  SIM_PCE1 = SIM_PCE1_INIT;
  #endif
  #ifdef SIM_PCE2_INIT
  SIM_PCE2 = SIM_PCE2_INIT;
  #endif
  #ifdef SIM_PCE3_INIT
  SIM_PCE3 = SIM_PCE3_INIT;
  #endif
  #ifdef SIM_SD0_INIT
  SIM_SD0 = SIM_SD0_INIT;
  #endif
  #ifdef SIM_SD1_INIT
  SIM_SD1 = SIM_SD1_INIT;
  #endif
  #ifdef SIM_SD2_INIT
  SIM_SD2 = SIM_SD2_INIT;
  #endif
  #ifdef SIM_SD3_INIT
	SIM_SD3 = SIM_SD3_INIT;
  #endif
  #ifdef SIM_IPS0_INIT
    SIM_IPSn = SIM_IPS0_INIT;
  #endif
#if DEBUG_CLKO
      SIM_CLKOUT=0xF000;
      SIM_GPSCL = 0x30;
#endif
}

inline void GpioInit( void )
{
	// init GPIO_A
  #ifdef GPIO_A_PUR_INIT
  GPIOA_PUR = GPIO_A_PUR_INIT;
  #endif
  #ifdef GPIO_A_DR_INIT
  GPIOA_DR = GPIO_A_DR_INIT;
  #endif
  #ifdef GPIO_A_DDR_INIT
  GPIOA_DDR = GPIO_A_DDR_INIT;
  #endif
  #ifdef GPIO_A_PER_INIT
  GPIOA_PER = GPIO_A_PER_INIT;
  #endif
  #ifdef GPIO_A_IENR_INIT
  GPIOA_IENR = GPIO_A_IENR_INIT;
  #endif
  #ifdef GPIO_A_IPOLR_INIT
  GPIOA_IPOLR = GPIO_A_IPOLR_INIT;
  #endif
  #ifdef GPIO_A_PPMODE_INIT
  GPIOA_PPMODE = GPIO_A_PPMODE_INIT;
  #endif
  #ifdef GPIO_A_DRIVE_INIT
  GPIOA_DRIVE = GPIO_A_DRIVE_INIT;
  #endif
	
	// init GPIO_B
  #ifdef GPIO_B_PUR_INIT
  GPIOB_PUR = GPIO_B_PUR_INIT;
  #endif
  #ifdef GPIO_B_DR_INIT
  GPIOB_DR = GPIO_B_DR_INIT;
  #endif
  #ifdef GPIO_B_DDR_INIT
  GPIOB_DDR = GPIO_B_DDR_INIT;
  #endif
  #ifdef GPIO_B_PER_INIT
  GPIOB_PER = GPIO_B_PER_INIT;
  #endif
  #ifdef GPIO_B_IENR_INIT
  GPIOB_IENR = GPIO_B_IENR_INIT;
  #endif
  #ifdef GPIO_B_IPOLR_INIT
  GPIOB_IPOLR = GPIO_B_IPOLR_INIT;
  #endif
  #ifdef GPIO_B_PPMODE_INIT
  GPIOB_PPMODE = GPIO_B_PPMODE_INIT;
  #endif
  #ifdef GPIO_B_DRIVE_INIT
  GPIOB_DRIVE = GPIO_B_DRIVE_INIT;
  #endif

	// init GPIO_C
  #ifdef GPIO_C_PUR_INIT
  GPIOC_PUR = GPIO_C_PUR_INIT;
  #endif
  #ifdef GPIO_C_DR_INIT
  GPIOC_DR = GPIO_C_DR_INIT;
  #endif
  #ifdef GPIO_C_DDR_INIT
  GPIOC_DDR = GPIO_C_DDR_INIT;
  #endif
  #ifdef GPIO_C_PER_INIT
  GPIOC_PER = GPIO_C_PER_INIT;
  #endif
  #ifdef GPIO_C_IENR_INIT
  GPIOC_IENR = GPIO_C_IENR_INIT;
  #endif
  #ifdef GPIO_C_IPOLR_INIT
  GPIOC_IPOLR = GPIO_C_IPOLR_INIT;
  #endif
  #ifdef GPIO_C_PPMODE_INIT
  GPIOC_PPMODE = GPIO_C_PPMODE_INIT;
  #endif
  #ifdef GPIO_C_DRIVE_INIT
  GPIOC_DRIVE = GPIO_C_DRIVE_INIT;
  #endif

	// init GPIO_D
  #ifdef GPIO_D_PUR_INIT
  GPIOD_PUR = GPIO_D_PUR_INIT;
  #endif
  #ifdef GPIO_D_DR_INIT
  GPIOD_DR = GPIO_D_DR_INIT;
  #endif
  #ifdef GPIO_D_DDR_INIT
  GPIOD_DDR = GPIO_D_DDR_INIT;
  #endif
  #ifdef GPIO_D_PER_INIT
  GPIOD_PER = GPIO_D_PER_INIT;
  #endif
  #ifdef GPIO_D_IENR_INIT
  GPIOD_IENR = GPIO_D_IENR_INIT;
  #endif
  #ifdef GPIO_D_IPOLR_INIT
  GPIOD_IPOLR = GPIO_D_IPOLR_INIT;
  #endif
  #ifdef GPIO_D_PPMODE_INIT
  GPIOD_PPMODE = GPIO_D_PPMODE_INIT;
  #endif
  #ifdef GPIO_D_DRIVE_INIT
  GPIOD_DRIVE = GPIO_D_DRIVE_INIT;
  #endif

	// init GPIO_E
  #ifdef GPIO_E_PUR_INIT
  GPIOE_PUR = GPIO_E_PUR_INIT;
  #endif
  #ifdef GPIO_E_DR_INIT
  GPIOE_DR = GPIO_E_DR_INIT;
  #endif
  #ifdef GPIO_E_DDR_INIT
  GPIOE_DDR = GPIO_E_DDR_INIT;
  #endif
  #ifdef GPIO_E_PER_INIT
  GPIOE_PER = GPIO_E_PER_INIT;
  #endif
  #ifdef GPIO_E_IENR_INIT
  GPIOE_IENR = GPIO_E_IENR_INIT;
  #endif
  #ifdef GPIO_E_IPOLR_INIT
  GPIOE_IPOLR = GPIO_E_IPOLR_INIT;
  #endif
  #ifdef GPIO_E_PPMODE_INIT
  GPIOE_PPMODE = GPIO_E_PPMODE_INIT;
  #endif
  #ifdef GPIO_E_DRIVE_INIT
  GPIOE_DRIVE = GPIO_E_DRIVE_INIT;
  #endif

	// init GPIO_F
  #ifdef GPIO_F_PUR_INIT
  GPIOF_PUR = GPIO_F_PUR_INIT;
  #endif
  #ifdef GPIO_F_DR_INIT
  GPIOF_DR = GPIO_F_DR_INIT;
  #endif
  #ifdef GPIO_F_DDR_INIT
  GPIOF_DDR = GPIO_F_DDR_INIT;
  #endif
  #ifdef GPIO_F_PER_INIT
  GPIOF_PER = GPIO_F_PER_INIT;
  #endif
  #ifdef GPIO_F_IENR_INIT
  GPIOF_IENR = GPIO_F_IENR_INIT;
  #endif
  #ifdef GPIO_F_IPOLR_INIT
  GPIOF_IPOLR = GPIO_F_IPOLR_INIT;
  #endif
  #ifdef GPIO_F_PPMODE_INIT
  GPIOF_PPMODE = GPIO_F_PPMODE_INIT;
  #endif
  #ifdef GPIO_F_DRIVE_INIT
  GPIOF_DRIVE = GPIO_F_DRIVE_INIT;
  #endif
}


inline void XbarInit( void )
{
  #ifdef XBAR_A_SEL0_INIT
  XBARA_SEL0 = XBAR_A_SEL0_INIT;
  #endif
  #ifdef XBAR_A_SEL1_INIT
  XBARA_SEL1 = XBAR_A_SEL1_INIT;
  #endif
  #ifdef XBAR_A_SEL2_INIT
  XBARA_SEL2 = XBAR_A_SEL2_INIT;
  #endif
  #ifdef XBAR_A_SEL3_INIT
  XBARA_SEL3 = XBAR_A_SEL3_INIT;
  #endif
  #ifdef XBAR_A_SEL4_INIT
  XBARA_SEL4 = XBAR_A_SEL4_INIT;
  #endif
  #ifdef XBAR_A_SEL5_INIT
  XBARA_SEL5 = XBAR_A_SEL5_INIT;
  #endif
  #ifdef XBAR_A_SEL6_INIT
  XBARA_SEL6 = XBAR_A_SEL6_INIT;
  #endif
  #ifdef XBAR_A_SEL7_INIT
  XBARA_SEL7 = XBAR_A_SEL7_INIT;
  #endif
  #ifdef XBAR_A_SEL8_INIT
  XBARA_SEL8 = XBAR_A_SEL8_INIT;
  #endif
  #ifdef XBAR_A_SEL9_INIT
  XBARA_SEL9 = XBAR_A_SEL9_INIT;
  #endif
  #ifdef XBAR_A_SEL10_INIT
  XBARA_SEL10 = XBAR_A_SEL10_INIT;
  #endif
  #ifdef XBAR_A_SEL11_INIT
  XBARA_SEL11 = XBAR_A_SEL11_INIT;
  #endif
  #ifdef XBAR_A_SEL12_INIT
  XBARA_SEL12 = XBAR_A_SEL12_INIT;
  #endif
  #ifdef XBAR_A_SEL13_INIT
  XBARA_SEL13 = XBAR_A_SEL13_INIT;
  #endif
  #ifdef XBAR_A_SEL14_INIT
  XBARA_SEL14 = XBAR_A_SEL14_INIT;
  #endif
  #ifdef XBAR_A_SEL15_INIT
  XBARA_SEL15 = XBAR_A_SEL15_INIT;
  #endif
  #ifdef XBAR_A_SEL16_INIT
  XBARA_SEL16 = XBAR_A_SEL16_INIT;
  #endif
  #ifdef XBAR_A_SEL17_INIT
  XBARA_SEL17 = XBAR_A_SEL17_INIT;
  #endif
  #ifdef XBAR_A_SEL18_INIT
  XBARA_SEL18 = XBAR_A_SEL18_INIT;
  #endif
  #ifdef XBAR_A_SEL19_INIT
  XBARA_SEL19 = XBAR_A_SEL19_INIT;
  #endif
  #ifdef XBAR_A_SEL20_INIT
  XBARA_SEL20 = XBAR_A_SEL20_INIT;
  #endif

  #ifdef XBAR_A_CTRL0_INIT
  XBARA_CTRL0 = XBAR_A_CTRL0_INIT;
  #endif
  #ifdef XBAR_A_CTRL1_INIT
	XBARA_CTRL1 = XBAR_A_CTRL1_INIT;
  #endif
}

inline void CommInputTimerInit( void )
{
	//clock is enabled by SIM module

    // Configure control register - mask off source to keep timer from starting
    TMR_3_CTRL      = ( QT_A3_CTRL_INIT & ~TMR_3_CTRL_CM );
  #ifdef QT_A3_SCR_INIT
  TMR_3_SCTRL     = QT_A3_SCR_INIT;
  #endif
  // Configure the timer compare values
  #ifdef QT_A3_CMP1_INIT
  TMR_3_COMP1     = QT_A3_CMP1_INIT;
  #endif
  #ifdef QT_A3_CMP1_INIT
  TMR_3_COMP2     = QT_A3_CMP2_INIT;
  #endif
  // Set the initial timer value
  #ifdef QT_A3_LOAD_INIT
  TMR_3_LOAD      = QT_A3_LOAD_INIT;
  #endif
  #ifdef QT_A3_COMSCR_INIT
  TMR_3_CSCTRL    = QT_A3_COMSCR_INIT;
  #endif

    // interrupt is disabled

    // Turn on the timer peripheral
    TMR_0_ENBL |= TMR_0_ENBL_ENBL_3;

    // start the timer
    TMR_3_CTRL      |= ( QT_A3_CTRL_INIT & TMR_3_CTRL_CM );

    // Enable interrupts in the application
}

inline void CommReferenceTimerInit( void )
{
	//clock is enabled by SIM module

    // Configure control register - mask off source to keep timer from starting
    TMR_2_CTRL      = ( QT_A2_CTRL_INIT & ~TMR_2_CTRL_CM );
  #ifdef QT_A2_SCR_INIT
  TMR_2_SCTRL     = QT_A2_SCR_INIT;
  #endif
  // Configure the timer compare values
  #ifdef QT_A2_CMP1_INIT
  TMR_2_COMP1     = QT_A2_CMP1_INIT;
  #endif
  #ifdef QT_A2_CMP2_INIT
  TMR_2_COMP2     = QT_A2_CMP2_INIT;
  #endif
  // Set the initial timer value
  #ifdef QT_A2_LOAD_INIT
  TMR_2_LOAD      = QT_A2_LOAD_INIT;
  #endif
  #ifdef QT_A2_COMSCR_INIT
  TMR_2_CSCTRL    = QT_A2_COMSCR_INIT;
  #endif

    // Set timerA2 interrupt priority to disabled

    // Turn on the timer peripheral
    TMR_0_ENBL |= TMR_0_ENBL_ENBL_2;

    // start the timer
    TMR_2_CTRL      |= ( QT_A2_CTRL_INIT & TMR_2_CTRL_CM );

    // Enable interrupts in the application	
}

inline void DDMTimerInit( void )
{
    // TMRA0 init
	//clock is enabled by SIM module

	// Configure control register - mask off source to keep timer from starting
	#ifdef QT_A0_CTRL_INIT
	TMR_0_CTRL      = ( QT_A0_CTRL_INIT & ~TMR_0_CTRL_CM );
       #endif
	#ifdef QT_A0_SCR_INIT
	TMR_0_SCTRL     = QT_A0_SCR_INIT;
       #endif
	// Configure the timer compare values
	#ifdef QT_A0_CMP1_INIT
	TMR_0_COMP1     = QT_A0_CMP1_INIT;
       #endif
	#ifdef QT_A0_CMPLD1_INIT
      TMR_0_CMPLD1 = QT_A0_CMPLD1_INIT;
       #endif
	#ifdef QT_A0_CMP2_INIT
	TMR_0_COMP2     = QT_A0_CMP2_INIT;
       #endif
	#ifdef QT_A0_CMPLD2_INIT
      TMR_0_CMPLD2 = QT_A0_CMPLD2_INIT;
       #endif
	// Set the initial timer value
	#ifdef QT_A0_LOAD_INIT
	TMR_0_LOAD      = QT_A0_LOAD_INIT;
       #endif
	#ifdef QT_A0_COMSCR_INIT
	TMR_0_CSCTRL    = QT_A0_COMSCR_INIT;
       #endif

       // Set timerA0 interrupt priority
       SET_DDM_TMR_INTERRUPT_PRIORITY;

	// Turn on the timer peripheral
	//TMR_0_ENBL |= QT_A0_ENBL_INIT&TMR_0_ENBL_ENBL_0;  //Enabled in DDM start

	// start the timer
	#ifdef QT_A0_CTRL_INIT
	TMR_0_CTRL      |= ( QT_A0_CTRL_INIT & TMR_0_CTRL_CM );
       #endif

	// Enable interrupts in the application
}

inline void DmaInit( void )
{
  #ifdef DMA_BCR0_INIT
  DMA_DSR_BCR0 = DMA_BCR0_INIT;
  #endif
  #ifdef DMA_REQC_INIT
  DMA_REQC = DMA_REQC_INIT;
  #endif
  #ifdef DMA_SAR0_INIT
  DMA_SAR0 = DMA_SAR0_INIT;
  #endif
  #ifdef DMA_DAR0_INIT
  DMA_DAR0 = DMA_DAR0_INIT;
  #endif
  #ifdef DMA_DCR0_INIT
  DMA_DCR0 = DMA_DCR0_INIT;
  #endif

    //Set DMACH0 interrupt priority
    INTC_IPR3 &= ~INTC_IPR3_DMACH0;
    INTC_IPR3 |= 1<<6;
}

void WatchdogTimerInit( void )
{
    // Enable Computer Operating Properly peripheral
    // NOTE: The watchdog timer clock and prescaler is configurable

    // Disable the timer
    COP_CTRL = 0;
    // Set the timeout counter value
#ifdef COP_COPTO_INIT
    COP_TOUT = COP_COPTO_INIT;
#endif
    // Re-initialize the timer
#ifdef COP_COPCTL_INIT
    COP_CTRL = COP_COPCTL_INIT;
#endif
}

inline void PitInit( void )
{
#ifdef PIT_0_CTRL_INIT
  PIT0_CTRL = PIT_0_CTRL_INIT;  // todo: change to gct settings, source from alternae clock 2, ROSC_8M
#endif
#ifdef PIT_0_MOD_INIT
  PIT0_MOD = PIT_0_MOD_INIT;            
#endif
  PIT0_CTRL |= PIT0_CTRL_CNT_EN;      /* Run PIT */ 
}


//------------------------------------------------------------------------------
void HwInit( void )
{
    //init SIM module
    SimInit();
    //init GPIO modules
    GpioInit();
    //init XBar module
    XbarInit();
#if DEBUG_PWM_TRIG0
    XBARA_SEL5 &= ~0x3F00;
    XBARA_SEL5 |= 0x1200;   // Routing PWM0_TRIG0 to XB_OUT11
    SIM_GPSCL &= ~SIM_GPSCL_C2;
    SIM_GPSCL |= SIM_GPSCL_C2_0; // GPIOC2 is XB_OUT11
#endif
    //protect GPIO until reset
    //SIM_PROT |= ( SIM_PROT & 0x000C ) | ( SIM_PROT_GIPSP );   // Mask this because GPIOF/I2C need to switch runtimely

    //init OCCS
    OccsInit();

    DDMTimerInit();
    DmaInit();
    //Workaround the FMC_PFB0CR register is not initiated when debug 
    FMC_PFB0CR = 0x1100001F;

	// Initialize 16-bit timer as 16x CLK reference for IrDA MAC
    //IrdaClockTimerInit(); //Irda is replaced by UART on A11

#if SOUND_SUPPORTED
    SoundInit();
#endif

    // Initialize LED control
    DisplayInitLedControl();
	
    // This platform does not have hardware configuration options
    // as originally designed for the GEMS. However, to work with
    // GEMS, we need to create and initialize the HwConfigOptions structure.

    // The wPowerLossIncrementalThreshold and wPowerLossBaseThreshold must
    // be defined in NMV appropriately for the defined multiplier...
    // NOTE: We will set the selection to '0' and disable
    HwConfigOptions.byPowerLossDetectionSelection = 0;
    // Set LED Selection to '0' (NVM control - only valid option)
    HwConfigOptions.byLedSelection                = 0;

    WCT_InitError();

#if QSCI0_ENABLED
    Qsci0Init();
#endif

    // Enable Flash erasure and modification, if necessary
#if WPTTX_DEBUG_FREEMASTER
    FlashControlInitialization();
#endif
    
     // Initialize the A/D
     AdcInit();

     
     //CompInit();

#if LOW_POWER_MODE_BY_TOUCH
      i2c_Init();   // I2C init must be ahead of TouchSensorInit
#endif
     
     // Initialize communication operation
     //CommInputTimerInit();
     CommReferenceTimerInit();
     ENABLE_CPU_INTERRUPTS;
     __EI0();
}

