/*******************************************************************************
*
* Copyright 2012-2014 Freescale Semiconductor, Inc.
* Copyright 2018 NXP.
* All rights reserved.
*******************************************************************************/

#ifndef __SOUND_H__

    #define __SOUND_H__

    //----------
    // INCLUDES
    //----------

    #include "application.h"
    #include "peripheralinit.h"
    #include "wct_hal_cfg.h"
    #include "wct_lib.h"


    //----------
    // DEFINES
    //----------
    #ifndef AC_SOUND_ENABLED
    #define AC_SOUND_ENABLED        FALSE
    #endif

    #ifndef DC_SOUND_ENABLED
    #define DC_SOUND_ENABLED        FALSE
    #endif


    //----------
    // TYPEDEFS
    //----------
    typedef enum
    {
        SOUND_NONE = 0,
        SOUND_POWER_ON,
        SOUND_POWER_OFF,
        MAX_SOUND_TYPES

    } SOUND_TYPES;


    
    //---------
    // DEFINES
    //---------
    //AC beeper control
    #define ENABLE_SOUND_PWM_OUTPUT { ENABLE_PWM2; ENABLE_PWMB2_OUT;}
    #define DISABLE_SOUND_PWM_OUTPUT { DISABLE_PWM2; DISABLE_PWMB2_OUT;}

    //DC beeper control
    #define PIN_DC_BEEPER_LOW               //GPIO_E3_CLEAR 
    #define PIN_DC_BEEPER_HIGH              //GPIO_E3_SET 


    //-----------
    // VARIABLES
    //-----------


    //-----------
    // FUNCTIONS
    //-----------

    void SoundSetFrequency( WORD wFrequency );
    void SoundInit( void );
    void SoundQueueUpdate( SOUND_TYPES eSoundType );

    #if LOW_POWER_MODE_SUPPORTED
    WORD SoundProcessTimeSlice( WORD wTimePassed );
    #else
    void SoundProcessTimeSlice( WORD wTimePassed );
    #endif

#endif
