/*******************************************************************************
*
* Copyright 2012-2014 Freescale Semiconductor, Inc.
* Copyright 2018 NXP.
* All rights reserved.
*******************************************************************************/

//---------------------------
// STANDARD LIBRARY INCLUDES
//---------------------------


//----------------------
// APPLICATION INCLUDES
//----------------------
#include "i2c.h"
#include "touch.h"
#include "defines.h"
#include "lowPowerMode.h"

#if LOW_POWER_MODE_BY_TOUCH

//-----------------
// PRIVATE DEFINES
//-----------------

//-------------------
// PRIVATE VARIABLES
//-------------------
const T_MPR121_SETTING_STRUCT MPR121_setting_table[]={
  //Reset MPR121 if not reset correctly
  {0x80,0x63},  //Soft reset  
  {0x5E,0x00},  //Stop mode   
    
  //touch pad baseline filter
  //rising                                     
  {0x2B,0x01}, //0xFF// MAX HALF DELTA Rising
  {0x2C,0x01}, //0xFF// NOISE HALF DELTA Rising
  {0x2D,0x0E}, // //0 NOISE COUNT LIMIT Rising
  {0x2E,0x00}, // DELAY LIMIT Rising
  //falling
  {0x2F,0x01}, // MAX HALF DELTA Falling
  {0x30,0x05}, // NOISE HALF DELTA Falling
  {0x31,0x01}, // NOISE COUNT LIMIT Falling
  {0x32,0x00}, // //2//DELAY LIMIT Falling
  //touched
  {0x33,0x00}, // Noise half delta touched 
  {0x34,0x00}, // Noise counts touched
  {0x35,0x00}, //Filter delay touched
    
  
  ////Prox baseline filter
  ////rising
  //{0x36,0x0f, //0xFF// MAX HALF DELTA Rising
  //{0x37,0x0f, //0xFF// NOISE HALF DELTA Rising
  //{0x38,0x00, // NOISE COUNT LIMIT Rising
  //{0x39,0x00, // DELAY LIMIT Rising
  ////falling
  //{0x3A,0x01, // MAX HALF DELTA Falling
  //{0x3B,0x01, // NOISE HALF DELTA Falling
  //{0x3C,0xff, // NOISE COUNT LIMIT Falling
  //{0x3D,0xff, // DELAY LIMIT Falling
  ////touched
  //{0x3E,0x00, //ff 
  //{0x3F,0x00, //1f 
  //{0x40,0x00, // 
  
  
  /**************************************************
  *
  *    If manual setting used, need set baseline value.
  *    If auto setting used, need not set baseline value.
  *
  ***************************************************/
  
  /* 
  //baseline value
  IIC_ByteWrite(0x1e,BASELINE_VAL);
  IIC_ByteWrite(0x1f,BASELINE_VAL);
  IIC_ByteWrite(0x20,BASELINE_VAL);
  IIC_ByteWrite(0x21,BASELINE_VAL);
  IIC_ByteWrite(0x22,BASELINE_VAL);
  IIC_ByteWrite(0x23,BASELINE_VAL);
  IIC_ByteWrite(0x24,BASELINE_VAL);
  IIC_ByteWrite(0x25,BASELINE_VAL);
  IIC_ByteWrite(0x26,BASELINE_VAL);
  IIC_ByteWrite(0x27,BASELINE_VAL);
  IIC_ByteWrite(0x28,BASELINE_VAL);
  IIC_ByteWrite(0x29,BASELINE_VAL);
  IIC_ByteWrite(0x2a,BASELINE_VAL);     */  
  
  
  //Touch pad threshold
  
  //{0x41,TouchThre}, // ELE0 TOUCH THRESHOLD
  //{0x42,ReleaThre}, // ELE0 RELEASE THRESHOLD
  //{0x43,TouchThre}, // ELE1 TOUCH THRESHOLD
  //{0x44,ReleaThre}, // ELE1 RELEASE THRESHOLD
  //{0x45,TouchThre}, // ELE2 TOUCH THRESHOLD
  //{0x46,ReleaThre}, // ELE2 RELEASE THRESHOLD
  //{0x47,TouchThre}, // ELE3 TOUCH THRESHOLD
  //{0x48,ReleaThre}, // ELE3 RELEASE THRESHOLD
  //{0x49,TouchThre}, // ELE4 TOUCH THRESHOLD
  //{0x4A,ReleaThre}, // ELE4 RELEASE THRESHOLD
  //{0x4B,TouchThre}, // ELE5 TOUCH THRESHOLD
  //{0x4C,ReleaThre}, // ELE5 RELEASE THRESHOLD
  //{0x4D,TouchThre}, // ELE6 TOUCH THRESHOLD
  //{0x4E,ReleaThre}, // ELE6 RELEASE THRESHOLD
  {0x4F,TouchThre}, // ELE7 TOUCH THRESHOLD
  {0x50,ReleaThre}, // ELE7 RELEASE THRESHOLD
  //{0x51,TouchThre}, // ELE8 TOUCH THRESHOLD
  //{0x52,ReleaThre}, // ELE8 RELEASE THRESHOLD
  //{0x53,TouchThre}, // ELE9 TOUCH THRESHOLD
  //{0x54,ReleaThre}, // ELE9 RELEASE THRESHOLD
  //{0x55,TouchThre}, // ELE10 TOUCH THRESHOLD
  //{0x56,ReleaThre}, // ELE10 RELEASE THRESHOLD
  //{0x57,TouchThre}, // ELE11 TOUCH THRESHOLD
  //{0x58,ReleaThre}, // ELE11 RELEASE THRESHOLD
  
  /**************************************************************
  **
  **       If not using global setting, need to set each electrode
  **       If using manual setting, need set CDC, CDT register.
  **       If using auto setting, need not set CDC, CDT register.
  **
  ***************************************************************/  
  /* 
  //cdc
  IIC_ByteWrite(0x5f,0x01);   //  1uA
  IIC_ByteWrite(0x60,0x01);
  IIC_ByteWrite(0x61,0x01);
  IIC_ByteWrite(0x62,0x01);
  IIC_ByteWrite(0x63,0x01);
  IIC_ByteWrite(0x64,0x01);
  IIC_ByteWrite(0x65,0x0b);   // 6th ele   10uA
  IIC_ByteWrite(0x66,0x0b);   // 7         10
  IIC_ByteWrite(0x67,0x0b);   // 8         10
  IIC_ByteWrite(0x68,0x0b);   // 9         6
  IIC_ByteWrite(0x69,0x0b);   // 10        8
  IIC_ByteWrite(0x6a,0x0b);   // 11        10
  
  //cdt
  IIC_ByteWrite(0x6c,0x44);   //  32uS
  IIC_ByteWrite(0x6d,0x44);
  IIC_ByteWrite(0x6e,0x44);
  IIC_ByteWrite(0x6f,0x44);
  IIC_ByteWrite(0x70,0x44);
  IIC_ByteWrite(0x71,0x44);     */
    
  
  //Prox threshold
  //{0x59,Prox_TouchThre}, // ELE12 TOUCH THRESHOLD
  //{0x5A,Prox_ReleaThre}, // ELE12 RELEASE THRESHOLD
  
  //touch /release debounce
  {0x5B,0x00}, // Not used as we are using polling method, use for INT mode.
  
  //AFE configuration
  
  #if 1 //EN_DEBUG
  /****************************************************
  **    REG VAL       CDT(uS)      
  **     0x04          global CDT unused
  **     0x24          0.5
  **     0x44          1
  **     0x64          2
  **     0x84          4
  **     0xA4          8
  **     0xC4          16
  **     0xE4          32
  ****************************************************/
  {0x5D,0x07},   //SFI=18  X  ESI=16ms    
  //IIC_ByteWrite(0x5D,0x00); 
  /****************************************************************************
  **    REG VAL       CDC(uA)      
  **     0x00        global CDT unused       0x08         8       0x10      16
  **     0x01          1               0x09         9       ...........
  **     0x02          2               0x0A         10      0x3F      63  
  **     0x03          3               0x0B         11
  **     0x04          4               0x0C         12
  **     0x05          5               0x0D         13
  **     0x06          6               0x0E         14
  **     0x07          7               0x0F         15
  ****************************************************************************/
  {0x5C,0xC0},   //FFI=6  
  
  #else
  
  {0x5C,0x10}, // AFES=00 (6 samples, same as AFES in 0x7B ), CDC=16, 16uA( no need if ACE=1) 
  {0x5D,0x24}, // Ct=1,0.5us,TDS=0,4samples,TDI=4,16ms /0, 1ms
  {0x5E,0x80}, // Set Basline cali enabled  by loading 5MSB, still in stop mode  
  #endif
  
  
  //Auto configuration 
  
  // 08: Disable auto setting        0B:Enable auto setting
  {0x7B,0xCF}, // AFES=00 (one filter, enable auto setting, need not set CDT,CDC
                                     // retry=00 (no retry),
                                     // BVA=10 ( load 5MSB after AC),
                                     // ARE/ACE=11 
  //IIC_ByteWrite(0x7C,0x80);//Un available in datasheet. Skip charge time search, use 0x5D setting, OOR, AR, AC IE disabled                                  
                                      // Not used as Proximity CDC shall over 63uA if only use 0.5uS CDT , the TGL for proximity can not meet
                                      // Possible if set R(0x72)=0x03 ( Auto configure result)  alone.
  
  /***************************************************************
  *
  *    If use manual setting, need not set below 3 registers. 
  *
  *  -----------------------------------------------------------------------
  *  |                        |     B4             |     AA             |    AC          |   8C 
  *  |---------------------------------------------------------------------- 
  *  |Charging Voltage | Vdd*70.3125% | Vdd*66.4045% | Vdd*67.5% | Vdd*55%  
  *  | Vdd=3.2v          |     2.25V         |    1.773V         |   1.89V       |  0.99V
  *  -----------------------------------------------------------------------
  *   7D,7E,7F register value decide charging level.
  *
  ****************************************************************/
  
  {0x7D,0xC9}, // USL/f0/C8/BD/C0/9C/DF/E4 => 11.2V/3.2V/2.67V/2.8V/1.8V 
  {0x7E,0x83}, // LSL/d0/82/7A/7C/65/90/94         /3.2V/2.67V/2.8V/1.8V
  {0x7F,0xB5}, // TGL/e0/B4/AA/AC/8C/C8/CD  (target  for /max/3.2V/2.67V/2.8V/1.8V system)

  //{0x5E,0x00},
};

WORD wTouchIRQErr;

/*Debug data*/
#ifdef DEBUG_TOUCH
BYTE MPR121_setting_readback[MPR121_REGISTER_SIZE];
#endif

//BYTE bTouchIRQCnt;       /* Touch IRQ asserted count*/
BYTE touch_status; /* Touch status */

//-------------------
// PRIVATE FUNCTIONS
//-------------------

//------------------
// PUBLIC VARIABLES
//------------------

//------------------
// PUBLIC FUNCTIONS
//------------------
TOUCH_SENSOR_INTERRUPT;



void TouchSensorInit(void)
{
    WORD i,size;

    //GPIO_DR_backup=0;
    SIM_GPSFL &= 0xFF0F;           /* Config IO F2/3 to SCL0/SDA0 */
    SET_TOUCH_INTERRUPT_PRIORITY;
    switch_GPIO_or_I2C(PIN_I2C);   /*Set pin to I2C*/
    i2c_SelectSlave(MPR121_I2C_ADDR);

    /* Write MPR121 */
    size=sizeof(MPR121_setting_table)>>1;
    for(i=0;i<size;i++)
    {
        IIC_ByteWrite(MPR121_setting_table[i].addr,MPR121_setting_table[i].value);
    }
    
#ifndef DEBUG_TOUCH
    /*Disable touch*/
    touch_disable();
#else
    touch_enable();
    switch_GPIO_or_I2C(PIN_I2C);   /*set to I2C*/
    
    /* Dump MPR121 register */
    for(i=0;i<size;i++)
    {
        MPR121_setting_readback[i]=IIC_ByteRead(MPR121_setting_table[i].addr);
    }

    switch_GPIO_or_I2C(PIN_GPIO);   /*set to GPIO*/
#endif
}

void switch_GPIO_or_I2C(BYTE i2c_on)
{
    if(i2c_on)
    {   /* Set pin to I2C */
        i2c_Enable();
        GPIOF_PER |= BIT2+BIT3;   
    }
    else
    {   /* Set pin to GPIO output */
    	  i2c_Disable();
        GPIOF_PER &= ~(BIT2+BIT3);
        GPIOF_DDR |= BIT2+BIT3;
        GPIOF_DR  |= BIT2+BIT3;
    }
}

void MPR121_onOff(BYTE onOff)
{
    BYTE reg,value;

    reg=MPR121_ECR_ADDR; 
    if(onOff==TOUCH_ON)
        value=MPR121_ECR_ENABLE;
    else
        value=MPR121_ECR_DISABLE;

    switch_GPIO_or_I2C(PIN_I2C);   /* Set to I2C */
    IIC_ByteWrite(reg,value);      /* When MPR121 ECR writing, need not set chip to stop mode. */
    switch_GPIO_or_I2C(PIN_GPIO);  /* Set to GPIO */
}

void read_MPR121(BYTE reg, BYTE* value)
{
    switch_GPIO_or_I2C(PIN_I2C);   /* Set to I2C*/
    *value=IIC_ByteRead(reg);
    switch_GPIO_or_I2C(PIN_GPIO);  /* Set to GPIO*/
}

#if COIL_AS_TOUCH_ELECTRODE_SUPPORT
void relay_switch(BYTE state)
{
    /* GPIO-E4: relay set,    1: coil connected to touch
     * GPIO-E5: relay clear,  1: coil connected to power circuit */

    CLR_GPIO_TO_SWITCH_RELAY_TO_KEEP;       /* Relay keep */
    if(state==SWITCH_KEEP)     
        return;

    //TimerDelayMs(1);                       /* Delay some time.*/
    
    if(state==SWITCH_TOUCH)
    {   /* System sleep, connect to touch */
        SET_GPIO_TO_SWITCH_RELAY_TO_TOUCH;
        WCT_TimerDelayMs(100);                 /* Delay directly before touch on and system sleeps. */
        CLR_GPIO_TO_SWITCH_RELAY_TO_KEEP;  /* Relay keep */
    }
    else
    {   /* System wake up, connect to power, */
        SET_GPIO_TO_SWITCH_RELAY_TO_POWER;
#ifdef ENABLE_UNIT_TEST
        WCT_TimerDelayMs(100);                 /* Delay directly before touch on*/
        CLR_GPIO_TO_SWITCH_RELAY_TO_KEEP;  /* Relay keep */
#endif
    }

}
#endif

void touch_enable(void)
{
    touch_status=TOUCH_ON;
    MPR121_onOff(TOUCH_ON);
    #if COIL_AS_TOUCH_ELECTRODE_SUPPORT
    relay_switch(SWITCH_TOUCH);
    #endif
    ENABLE_TOUCH_IRQ;      /* Enable touch IO interrupt */
}

void touch_disable(void)
{
    touch_status=TOUCH_OFF;
    MPR121_onOff(TOUCH_OFF);
    #if COIL_AS_TOUCH_ELECTRODE_SUPPORT
    relay_switch(SWITCH_POWER);
    #endif
    DISABLE_TOUCH_IRQ;      /* Disable touch IO interrupt */
}

BYTE get_touch_status(void)
{
    return touch_status;
}

#endif

#pragma interrupt saveall /* Comment this line if the appropriate 'Interrupt preserve registers' property */
                         /* is set to 'yes' (#pragma interrupt saveall is generated before the ISR)      */
TOUCH_SENSOR_INTERRUPT
{
    BYTE value;

    CLEAR_TOUCH_IRQ_FLAG; // Clear GPIO interrupt flag

#if LOW_POWER_MODE_BY_TOUCH
  
    #if LOW_POWER_MODE_SUPPORTED
    wTxIdleTime=0; /* Reset idle timer */
    #endif
    #if (defined (DEBUG_TOUCH) || defined (ENABLE_UNIT_TEST))
    read_MPR121(MPR121_TOUCH_STATUS_ADDR, &value);    /* Read MPR121 register to clear its interrupt */
    #else
    if(touch_status==(BYTE)TOUCH_ON)
    {
        #if CUSTOMER_TOUCH
        Cpu_SetHighSpeed();     /* Set CPU full speed mode. */
        #else
        Cpu_SetHighSpeed_LP();     /* Set CPU full speed mode, then access I2C bus. */
        #endif
        read_MPR121(MPR121_TOUCH_STATUS_ADDR, &value);    /* Read MPR121 register to clear its interrupt */
        touch_disable();
        TICK_TIMER_INTERRUPT_ENABLE;   /* Enable TICK interrupt */
    }
    else
    {
        wTouchIRQErr++;
    }
    #endif
#endif

}
#pragma interrupt off



