/*******************************************************************************
*
* Copyright 2012-2014 Freescale Semiconductor, Inc.
* Copyright 2018 NXP.
* All rights reserved.
*******************************************************************************/

//---------------------------
// STANDARD LIBRARY INCLUDES
//---------------------------


//----------------------
// APPLICATION INCLUDES
//----------------------
#include "delay.h"


//-----------------
// PRIVATE DEFINES
//-----------------


//-------------------
// PRIVATE VARIABLES
//-------------------


//-------------------
// PRIVATE FUNCTIONS
//-------------------


//-------------------
// PUBLIC FUNCTIONS
//-------------------


//------------------------------------------------------------------------------
//
//  DelayUs
//
//  This is a rudimentary delay function based upon the CPU clock speed.
//  If the for() loop takes a finite number of instructions cycles to complete,
//  we can calculate the number of loops to run for a specified delay in usec.
//
//  NOTE: The calling function must pass the number of loop iterations to perform
//   (TerminalCount) which can be calculated with the CALC_TERMINAL_COUNT() macro.
//
//  WARNING: Due to optimization, the DelayUs function may not accurately provide
//  a 1us delay!
//
//------------------------------------------------------------------------------
void DelayUs( WORD wTerminalCount )
{
    volatile WORD wCount;

    for( wCount = 0; wCount < wTerminalCount; wCount++ ){};
}

