/*******************************************************************************
*
* Copyright 2012-2014 Freescale Semiconductor, Inc.
* Copyright 2018 NXP.
* All rights reserved.
*******************************************************************************/

//---------------------------
// STANDARD LIBRARY INCLUDES
//---------------------------


//----------------------
// APPLICATION INCLUDES
//----------------------
#include "peripheralInit.h"
#include "comparator.h"

//-----------------
// PRIVATE DEFINES
//-----------------


//-------------------
// PRIVATE VARIABLES
//-------------------


//-------------------
// PRIVATE FUNCTIONS
//-------------------


//------------------
// PUBLIC VARIABLES
//------------------


//------------------
// PUBLIC FUNCTIONS
//------------------

#if COMPARATORA_ENABLED
//-----------------------------------------------------------------------------
static void CompAInit( void )
{
    //ENABLE_CMPA_IPBUS_CLK; enabled by SYS module

  #ifdef HSCMP_A_CR0_INIT
  CMPA_CR0   = HSCMP_A_CR0_INIT;
  #endif
  #ifdef HSCMP_A_CR1_INIT
  CMPA_CR1   = HSCMP_A_CR1_INIT;
  #endif
  #ifdef HSCMP_A_FPR_INIT
  CMPA_FPR   = HSCMP_A_FPR_INIT;
  #endif
  #ifdef HSCMP_A_SCR_INIT
  CMPA_SCR   = HSCMP_A_SCR_INIT;
  #endif
  #ifdef HSCMP_A_DACCR_INIT
  CMPA_DACCR = HSCMP_A_DACCR_INIT +( COMPC_DAC_SETTING_COUNTS & COMP_DAC_VOLTAGE_SELECT_BITMASK );
  #endif
  #ifdef HSCMP_A_MUXCR_INIT
  CMPA_MUXCR = HSCMP_A_MUXCR_INIT;
  #endif

    ENABLE_COMPA;
}
#endif

#if COMPARATORB_ENABLED
//-----------------------------------------------------------------------------
static void CompBInit( void )
{
    //ENABLE_CMPB_IPBUS_CLK; enabled by SYS module

  #ifdef HSCMP_B_CR0_INIT
  CMPB_CR0   = HSCMP_B_CR0_INIT;
  #endif
  #ifdef HSCMP_B_CR1_INIT
  CMPB_CR1   = HSCMP_B_CR1_INIT;
  #endif
  #ifdef HSCMP_B_FPR_INIT
  CMPB_FPR   = HSCMP_B_FPR_INIT;
  #endif
  #ifdef HSCMP_B_SCR_INIT
  CMPB_SCR   = HSCMP_B_SCR_INIT;
  #endif
  #ifdef HSCMP_B_DACCR_INIT
  CMPB_DACCR = HSCMP_B_DACCR_INIT +( COMPC_DAC_SETTING_COUNTS & COMP_DAC_VOLTAGE_SELECT_BITMASK );
  #endif
  #ifdef HSCMP_B_MUXCR_INIT
  CMPB_MUXCR = HSCMP_B_MUXCR_INIT;
  #endif

    ENABLE_COMPB;
}
#endif

#if COMPARATORC_ENABLED
//-----------------------------------------------------------------------------
static void CompCInit( void )
{
    //ENABLE_CMPC_IPBUS_CLK; enabled by SYS module

  #ifdef HSCMP_C_CR0_INIT
  CMPC_CR0   = HSCMP_C_CR0_INIT;
  #endif
  #ifdef HSCMP_C_CR1_INIT
  CMPC_CR1   = HSCMP_C_CR1_INIT;
  #endif
  #ifdef HSCMP_C_FPR_INIT
  CMPC_FPR   = HSCMP_C_FPR_INIT;
  #endif
  #ifdef HSCMP_C_SCR_INIT
  CMPC_SCR   = HSCMP_C_SCR_INIT;
  #endif
  #ifdef HSCMP_C_DACCR_INIT
  CMPC_DACCR = HSCMP_C_DACCR_INIT +( COMPC_DAC_SETTING_COUNTS & COMP_DAC_VOLTAGE_SELECT_BITMASK );
  #endif
  #ifdef HSCMP_C_MUXCR_INIT
  CMPC_MUXCR = HSCMP_C_MUXCR_INIT;
  #endif

    ENABLE_COMPC;
}
#endif

#if COMPARATORD_ENABLED
//-----------------------------------------------------------------------------
static void CompDInit( void )
{
    //ENABLE_CMPD_IPBUS_CLK; enabled by SYS module

  #ifdef HSCMP_D_CR0_INIT
  CMPD_CR0   = HSCMP_D_CR0_INIT;
  #endif
  #ifdef HSCMP_D_CR1_INIT
  CMPD_CR1   = HSCMP_D_CR1_INIT;
  #endif
  #ifdef HSCMP_D_FPR_INIT
  CMPD_FPR   = HSCMP_D_FPR_INIT;
  #endif
  #ifdef HSCMP_D_SCR_INIT
  CMPD_SCR   = HSCMP_D_SCR_INIT;
  #endif
  #ifdef HSCMP_D_DACCR_INIT
  CMPD_DACCR = HSCMP_D_DACCR_INIT +( COMPC_DAC_SETTING_COUNTS & COMP_DAC_VOLTAGE_SELECT_BITMASK );
  #endif
  #ifdef HSCMP_D_MUXCR_INIT
  CMPD_MUXCR = HSCMP_D_MUXCR_INIT;
  #endif

    ENABLE_COMPD;
}
#endif

//-----------------------------------------------------------------------------
void CompInit( void )
{
    #if COMPARATORA_ENABLED
    CompAInit();
    #endif

    #if COMPARATORB_ENABLED
    CompBInit();
    #endif

    #if COMPARATORC_ENABLED
    CompCInit();
    #endif

    #if COMPARATORD_ENABLED
    CompDInit();
    #endif

}




